	TITLE	'CP/M 2.2 BIOS (SECOND RELEASE)'
;	SECOND RELEASE VERSION....!!!!!!
;	edited jul 91
;************************************************************
;*							    *
;*		C P / M     B I O S			    *
;*							    *
;************************************************************
;
;MODIFIED BY TOM BATES JULY 1982 
;A- LEAVES THE DISK DRIVES ON FOREVER...
;
;
; DATE OF ORIGINAL VERSION:  OCT 15, 1981
;
;
;
; SYSTEM SPECIFICATION CONSTANTS
;
;
QKVERS		EQU	22	; CP/M VERSION N.N
QKBVERS		EQU	11	; BIOS VERSION (N.N)
;
QKMSIZE		EQU	62	; MORY SIZE IN K BYTES
QLBASE		EQU	0	;BEGINNING OF ADDRESSABLE RAM
QKNDISKS	EQU	4	; NUMBER OF DISKS SUPPORTED
QKSECTRK	EQU	36	; NUMBER OF SECTORS PER TRACK
;
;
;
;
	MACLIB	DISKDEF	; FOR DISK TABLE DEFINITIONS
;
;	@CHK MACRO USED FOR CHECKING 8 BIT DISPLACMENTS
;
@CHK	MACRO	?DD	;; USED FOR CHECKING RANGE OF 8-BIT DISP.S
	IF (?DD GT 7FH) AND (?DD LT 0FF80H)
 'DISPLACEMENT RANGE ERROR - Z80 LIB'
	ENDIF
	ENDM
LDX	MACRO	?R,?D	
	@CHK	?D
	DB	0DDH,?R*8+46H,?D
	ENDM
LDY	MACRO	?R,?D	
	@CHK	?D
	DB	0FDH,?R*8+46H,?D
	ENDM
STX	MACRO	?R,?D	
	@CHK	?D
	DB	0DDH,70H+?R,?D
	ENDM
STY	MACRO	?R,?D	
	@CHK	?D
	DB	0FDH,70H+?R,?D
	ENDM
MVIX	MACRO	?N,?D	
	@CHK	?D
	DB	0DDH,36H,?D,?N
	ENDM
MVIY	MACRO	?N,?D	
	@CHK	?D
	DB	0FDH,36H,?D,?N
	ENDM
LDAI	MACRO		
	DB	0EDH,57H
	ENDM
LDAR	MACRO		
	DB	0EDH,5FH
	ENDM
STAI	MACRO		
	DB	0EDH,47H
	ENDM
STAR	MACRO		
	DB	0EDH,4FH
	ENDM

LXIX	MACRO	?NNNN	
	DB	0DDH,21H
	DW	?NNNN
	ENDM
LXIY	MACRO	?NNNN	
	DB	0FDH,21H
	DW	?NNNN
	ENDM
LDED	MACRO	?NNNN	
	DB	0EDH,5BH
	DW	?NNNN
	ENDM
LBCD	MACRO	?NNNN	
	DB	0EDH,4BH
	DW	?NNNN
	ENDM
LSPD	MACRO	?NNNN	
	DB	0EDH,07BH
	DW	?NNNN
	ENDM
LIXD	MACRO	?NNNN	
	DB	0DDH,2AH
	DW	?NNNN
	ENDM
LIYD	MACRO	?NNNN	
	DB	0FDH,2AH
	DW	?NNNN
	ENDM
SBCD	MACRO	?NNNN	
	DB	0EDH,43H
	DW	?NNNN
	ENDM
SDED	MACRO	?NNNN	
	DB	0EDH,53H
	DW	?NNNN
	ENDM
SSPD	MACRO	?NNNN	
	DB	0EDH,73H
	DW	?NNNN
	ENDM
SIXD	MACRO	?NNNN	
	DB	0DDH,22H
	DW	?NNNN
	ENDM
SIYD	MACRO	?NNNN	
	DB	0FDH,22H
	DW	?NNNN
	ENDM
SPIX	MACRO		
	DB	0DDH,0F9H
	ENDM
SPIY	MACRO		
	DB	0FDH,0F9H
	ENDM
PUSHIX	MACRO		
	DB	0DDH,0E5H
	ENDM
PUSHIY	MACRO		
	DB	0FDH,0E5H
	ENDM
POPIX	MACRO		
	DB	0DDH,0E1H
	ENDM
POPIY	MACRO		
	DB	0FDH,0E1H
	ENDM
EXAF	MACRO		
	DB	08H
	ENDM
EXX	MACRO		
	DB	0D9H
	ENDM
XTIX	MACRO		
	DB	0DDH,0E3H
	ENDM
XTIY	MACRO		
	DB	0FDH,0E3H
	ENDM

LDI	MACRO		
	DB	0EDH,0A0H
	ENDM
LDIR	MACRO		
	DB	0EDH,0B0H
	ENDM
LDD	MACRO		
	DB	0EDH,0A8H
	ENDM
LDDR	MACRO		
	DB	0EDH,0B8H
	ENDM
CCI	MACRO		
	DB	0EDH,0A1H
	ENDM
CCIR	MACRO		
	DB	0EDH,0B1H
	ENDM
CCD	MACRO		
	DB	0EDH,0A9H
	ENDM
CCDR	MACRO		
	DB	0EDH,0B9H
	ENDM

ADDX	MACRO	?D	
	@CHK	?D
	DB	0DDH,86H,?D
	ENDM
ADDY	MACRO	?D	
	@CHK	?D
	DB	0FDH,86H,?D
	ENDM
ADCX	MACRO	?D	
	@CHK	?D
	DB	0DDH,8EH,?D
	ENDM
ADCY	MACRO	?D	
	@CHK	?D
	DB	0FDH,8EH,?D
	ENDM
SUBX	MACRO	?D	
	@CHK	?D
	DB	0DDH,96H,?D
	ENDM
SUBY	MACRO	?D	
	@CHK	?D
	DB	0FDH,96H,?D
	ENDM
SBCX	MACRO	?D	
	@CHK	?D
	DB	0DDH,9EH,?D
	ENDM
SBCY	MACRO	?D	
	@CHK	?D
	DB	0FDH,9EH,?D
	ENDM
ANDX	MACRO	?D	
	@CHK	?D
	DB	0DDH,0A6H,?D
	ENDM
ANDY	MACRO	?D	
	@CHK	?D
	DB	0FDH,0A6H,?D
	ENDM
XORX	MACRO	?D	
	@CHK	?D
	DB	0DDH,0AEH,?D
	ENDM
XORY	MACRO	?D	
	@CHK	?D
	DB	0FDH,0AEH,?D
	ENDM
ORX	MACRO	?D	
	@CHK	?D
	DB	0DDH,0B6H,?D
	ENDM
ORY	MACRO	?D	
	@CHK	?D
	DB	0FDH,0B6H,?D
	ENDM
CMPX	MACRO	?D	
	@CHK	?D
	DB	0DDH,0BEH,?D
	ENDM
CMPY	MACRO	?D	
	@CHK	?D
	DB	0FDH,0BEH,?D
	ENDM
INRX	MACRO	?D	
	@CHK	?D
	DB	0DDH,34H,?D
	ENDM
INRY	MACRO	?D	
	@CHK	?D
	DB	0FDH,34H,?D
	ENDM
DCRX	MACRO	?D	
	@CHK	?D
	DB	0DDH,035H,?D
	ENDM
DCRY	MACRO	?D	
	@CHK	?D
	DB	0FDH,35H,?D
	ENDM

NEG	MACRO		
	DB	0EDH,44H
	ENDM
IM0	MACRO		
	DB	0EDH,46H
	ENDM
IM1	MACRO		
	DB	0EDH,56H
	ENDM
IM2	MACRO		
	DB	0EDH,5EH
	ENDM


BC	EQU	0
DE	EQU	2
HL	EQU	4
IX	EQU	4	
IY	EQU	4	
DADC	MACRO	?R	
	DB	0EDH,?R*8+4AH
	ENDM
DSBC	MACRO	?R	
	DB	0EDH,?R*8+42H
	ENDM
DADX	MACRO	?R	
	DB	0DDH,?R*8+09H
	ENDM
DADY	MACRO	?R	
	DB	0FDH,?R*8+09H
	ENDM
INXIX	MACRO		
	DB	0DDH,23H
	ENDM
INXIY	MACRO		
	DB	0FDH,23H
	ENDM
DCXIX	MACRO		
	DB	0DDH,2BH
	ENDM
DCXIY	MACRO		
	DB	0FDH,2BH
	ENDM

BIT	MACRO	?N,?R	
	DB	0CBH,?N*8+?R+40H
	ENDM
SETB	MACRO	?N,?R
	DB	0CBH,?N*8+?R+0C0H
	ENDM
RES	MACRO	?N,?R
	DB	0CBH,?N*8+?R+80H
	ENDM

BITX	MACRO	?N,?D	
	@CHK	?D
	DB	0DDH,0CBH,?D,?N*8+46H
	ENDM
BITY	MACRO	?N,?D	
	@CHK	?D
	DB	0FDH,0CBH,?D,?N*8+46H
	ENDM
SETX	MACRO	?N,?D	
	@CHK	?D
	DB	0DDH,0CBH,?D,?N*8+0C6H
	ENDM
SETY	MACRO	?N,?D	
	@CHK	?D
	DB	0FDH,0CBH,?D,?N*8+0C6H
	ENDM
RESX	MACRO	?N,?D	
	@CHK	?D
	DB	0DDH,0CBH,?D,?N*8+86H
	ENDM
RESY	MACRO	?N,?D	
	@CHK	?D
	DB	0FDH,0CBH,?D,?N*8+86H
	ENDM

JR	MACRO	?N
	DB	18H,?N-$-1
	ENDM
JRC	MACRO	?N
	DB	38H,?N-$-1
	ENDM
JRNC	MACRO	?N
	DB	30H,?N-$-1
	ENDM
JRZ	MACRO	?N
	DB	28H,?N-$-1
	ENDM
JRNZ	MACRO	?N
	DB	20H,?N-$-1
	ENDM
DJNZ	MACRO	?N
	DB	10H,?N-$-1
	ENDM

PCIX	MACRO		
	DB	0DDH,0E9H
	ENDM
PCIY	MACRO		
	DB	0FDH,0E9H
	ENDM

RETI	MACRO		
	DB	0EDH,4DH
	ENDM
RETN	MACRO		
	DB	0EDH,45H
	ENDM

INP	MACRO	?R	
	DB	0EDH,?R*8+40H
	ENDM
OUTP	MACRO	?R	
	DB	0EDH,?R*8+41H
	ENDM
INI	MACRO		
	DB	0EDH,0A2H
	ENDM
INIR	MACRO		
	DB	0EDH,0B2H
	ENDM
IND	MACRO		
	DB	0EDH,0AAH
	ENDM
INDR	MACRO		
	DB	0EDH,0BAH
	ENDM
OUTI	MACRO		
	DB	0EDH,0A3H
	ENDM
OUTIR	MACRO		
	DB	0EDH,0B3H
	ENDM
OUTD	MACRO		
	DB	0EDH,0ABH
	ENDM
OUTDR	MACRO		
	DB	0EDH,0BBH
	ENDM


RLCR	MACRO	?R	
	DB	0CBH, 00H + ?R
	ENDM
RLCX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 06H
	ENDM
RLCY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 06H
	ENDM
RALR	MACRO	?R	
	DB	0CBH, 10H+?R
	ENDM
RALX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 16H
	ENDM
RALY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 16H
	ENDM
RRCR	MACRO	?R	
	DB	0CBH, 08H + ?R
	ENDM
RRCX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 0EH
	ENDM
RRCY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 0EH
	ENDM
RARR	MACRO	?R	
	DB	0CBH, 18H + ?R
	ENDM
RARX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 1EH
	ENDM
RARY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 1EH
	ENDM
SLAR	MACRO	?R	
	DB	0CBH, 20H + ?R
	ENDM
SLAX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 26H
	ENDM
SLAY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 26H
	ENDM
SRAR	MACRO	?R	
	DB	0CBH, 28H+?R
	ENDM
SRAX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 2EH
	ENDM
SRAY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 2EH
	ENDM
SRLR	MACRO	?R	
	DB	0CBH, 38H + ?R
	ENDM
SRLX	MACRO	?D	
	@CHK	?D
	DB	0DDH, 0CBH, ?D, 3EH
	ENDM
SRLY	MACRO	?D	
	@CHK	?D
	DB	0FDH, 0CBH, ?D, 3EH
	ENDM
RLD	MACRO		
	DB	0EDH, 6FH
	ENDM
RRD	MACRO		
	DB	0EDH, 67H
	ENDM
;
;
;
;
QKBIAS		EQU	(QKMSIZE-20)*1024
QLCCP		EQU	3400H+QKBIAS+QLBASE	; START OF CCP
QLBDOS		EQU	806H+QLCCP	; START OF BDOS
QLBIOS		EQU	1600H+QLCCP	; START OF BIO
;
;
; EQUATES FOR ASCII CONTROL CHARACTERS
;
QKCTLC		EQU	3	; CONTROL-C
QKLF		EQU	10	; LINE FEED
QKCR		EQU	13	; RETURN
QKCTLZ		EQU	26	; CONTROL-Z (EOF)
;
;
;
;
; EQUATES FOR IOBYTE IMPLEMTATION
;
; IOBYTE MASKS
QMILST		EQU	11000000B	; LIST DEVICE
QMIPUN		EQU	00110000B	; PUNCH DEVICE
QMIRDR		EQU	00001100B	; READER DEVICE
QMICON		EQU	00000011B	; CONSOLE DEVICE
;
; DEFAULT IOBYTE
QKDEFIO		EQU	10010101B	; LST=LPT, PUN=PTP, RDR=PTR, CON=CRT
;
;
;
; PORT IDENTIFICATION FOR V180
;
; RS232C CONTROL PORT ADDRESSES
;
QPTTY		EQU	49H	; PRINTER PORT
QPCRT		EQU	41H	; CONSOLE PORT
QPUC1		EQU	51H	; GENERAL PURPOSE PORT
QPPTR		EQU	59H	; COMMUNICATIONS PORT
QPPTP		EQU	QPPTR
QPBAUD		EQU	90H	; BAUD RATE PORT
;
; DISK CONTROLLER POR
;
QPCOMD		EQU	78H	; FDC COMMAND/STATUS REG
QPTRKRG		EQU	79H	; FDC TRACK REGISTER
QPSECRG		EQU	7AH	; FDC SECTOR REGISTER
QPDATA		EQU	7BH	; FDC DATA REGISTER
QPSTAT		EQU	80H	; GENERAL FD STATUS REGISTER
;
; OTHER PORTS
;
QPRTRST		EQU	90H	; RT CLOCK RESET PORT
;
	PAGE
;************************************************************
;*							    *
;*		JUMP TABLE FOR BIOS ROUTINES		    *
;*							    *
;************************************************************
;
	ORG	QLBIOS
;
	JMP	BOOTCOLD
	JMP	BOOTWARM
	JMP	CONST
	JMP	CONIN
	JMP	CONOUT
	JMP	CLIST
	JMP	CPUNCH
	JMP	CREADER
	JMP	DHOME
	JMP	DSELDSK
	JMP	DSETTRK
	JMP	DSETSEC
	JMP	DSETDMA
	JMP	DREAD
	JMP	DWRITE
	JMP	CLISTST
	JMP	DSECTRAN

	PAGE
;
;************************************************************
;*							    *
;*		CONFIGURATION AREA			    *
;*							    *
;************************************************************
;
;
; INITIALIZATION VALUES FOR RS232 PORTS
;
B@232BAU	DB	QKB1200+QKB300 SHL 3	;BAUD RATE COSTANTS
B@TTYMOD	DB	QMM7BIT+QMMST2+QMMX16	;TTY PORT MODE BYTE
B@UC1MOD	DB	QMM8BIT+QMMST1+QMMX16	;UC1 PORT MODE BYTE
B@PTRMOD	DB	QMM8BIT+QMMST1+QMMX16	;PTR PORT MODE BYTE
B@VTFLAGS	DB	0	;VT-125 MODE/STATUS BYTE. INIT:VT100,CRT
B@QKBVERS	DB	QKBVERS		;VERSION ID CODE (2ND RELEASE)
;
;
;************************************************************
;*							    *
;*		BOOTSTRAP ROUTINES			    *
;*							    *
;************************************************************
;
;
QKNSECTS	EQU	(QLBIOS-QLCCP)/128	; NUMBER OF SECTORS TO LOAD
;
QLIOBYT		EQU	3	; IOBYTE
QLCDISK		EQU	4	; LOGGED IN DISK NUMR
QLBUFF		EQU	80H	; DEFAULT BUFFER AREA
QLTPA		EQU	100H	; BEGINNING OF TPA
QLBTSTK		EQU	QLBUFF	; STACK LOC FOR BOOT ROUTINES
;
;
; RST INTERRUPT VECTOR LOCATIONS
;
QLRST0		EQU	0
QLRST1		EQU	8
QLRST2		EQU	2*8
QLRST3		EQU	3*8
QLRST4		EQU	4*8
QLRST5		EQU	5*8
QLRST6		EQU	6*8
QLRST7		EQU	7*8
;
;
QKBOOTRT	EQU	4	; WARM BOOT RETRIES
;
;
; "BOOTCOLD"  -  ENTERED FROM BOOTSTRAP LOADER.
;	DISPLAYS SIGNON MESSAGE, INITIALIZES LOW RAM AREAS.
;
BOOTCOLD:
	DI		; DISABLE INTERRUPTS
	LXI	SP,QLBTSTK
	MVI	A,QKDEFIO	; DEFAULT IOBYTE SETTING
	STA	QLIOBYT	
	CALL	BOOTINIT  ; SET UP LOW MEMORY, RS-232, AND VT-100
	CALL	PVT100IQ	; SEND INQUIRY SEQUENCE
	CALL	UILPRT	; DSPLAY SIGNON MESSAGE
; SIGNON MESSAGE TEXT
	DB	'CP/M VERSION 2.2 BIOS v1.2',QKCR,QKLF
	DB	'(C) 1981 Digital Research, Inc.',QKCR,QKLF,0
;
; SPECIAL CODE FOR VT-180 
	IN	QPSTAT	; GET BOOT DRIVE NUMBER
	ANI	3	; MASK DISK NUMBER
	STA	B@WBDRV	; STORE FOR WARM BOOT USE
	STA	B@DRIVE	; STORE AS CURRENT DRIVE
	STA	QLCDISK	;SET INITIALLY TO DISK A
; INITIALIZE BLOCK/DEBLOCK VARIABLES
	XRA	A
	STA	B@WRFLAG	; RESET WRITE FLAG
	CMA
	STA	B@BDRIVE	; SET BUFFER DRIVE TO X'FF'
	JMP	BOOTCOM	;GO TO COMMON BOOT CODE
;
;
; "BOOTWARM"  -  READS CCP AND BDOS FROM SYSTEM TRACKS INTO RAM.
;
BOOTWARM:
	LXI	SP,QLBTSTK	; USE BUFFER F STACK
	CALL	BOOTINIT	; SET UP VECTORS, RS-232, VT-100
	MVI	C,QKBOOTRT	;MAX RETRIES
BOOTW06:
	PUSH	B
; READ LAST SECTOR FIRST TO SET DRIVE AND TRACK
;
	LDA	B@WBDRV		; GET WARM BOOT DRIVE
	MOV	C,A		; MOVE FOR CALL
	CALL	DSELDSK		; SELECT DRIVE
	LXI	B,1		; SET TCK 1
	CALL	DSETTRK
	MVI	C,8		; SET SECTOR 8 (IN PHYS. SECTOR 3)
	CALL	DSETSEC
	LXI	B,QLCCP-128+11*512 ; DMA ADDR FOR LAST SECTOR
	CALL	DSETDMA
	CALL	DREAD		; READ THE LOGICAL SECTOR
	ORA	A		; ERROR?
	JNZ	BOOTERR		;  YES - RETRY
; READ REMAINDER OF CCP AND BDOS WITH PHYSICAL READS
BOOTW10:	;ENTER HERE ON ERROR RETRIES
	LXI	H,QLCCP-128	; SET UP LOAD ADDRESS
	SHLD	W@HSTDMA
	CALL	DPRECAL	; START AT TRACK ZERO
	ORA	A	; ERROR?
	JNZ	BOOTERR	;  YES
	MVI	A,1	; START WITH SECTOR 1
	POP	B	; GET COUNTS BAK
	MVI	B,QKNSECTS/4	; SET NR OF PHYSICAL SECTORS
BOOTW20:
	PUSH	B	; AVE COUNTS
	STA	B@BSEC ; STORE SECTOR NUMBER
	CALL	DPREAD	; READ A PHYSICAL SECTOR
	ORA	A	; ERRORS?
	JNZ	BOOTERR	;  YES
	LHLD	W@HSTDMA ; GET LOAD ADDRESS
	INR	H	; ADD 512 TO IT
	INR	H
	SHLD	W@HSTDMA ; STORE IT
	LDA	B@BSEC  ; GET NUMBER OF SECTOR JUST READ
	CPI	9	; AT END OF TRACK?
	JC	BOOTW30	;  NOT YET
; STEP TO TRACK 1
	LXI	H,1	; SET TRACK TO 1
	SHLD	W@BTRACK
	CALL	DPSEEK	; DO SEEK
	ORA	A	; ERRORS?
	JNZ	BOOTERR	;  YES
	XRA	A	; CLEAR SECTOR NUMBER
BOOTW30:
	INR	A	; INCREMENT SECTOR NUMBER
	POP	B	; GET COUNTS
	DJNZ	BOOTW20	; LOOP UNTIL ALL SECTORS READ
	JMP	BOOTCOM	; GO TO COMMON BOOT CODE
;
;	ERROR CONDITION OCCURRED, PRINT MESSAGE AND RETRY
BOOTERR:
	POP	B	;RECALL COUNTS
	DCR	C
	JZ	BOOTER0
	JMP	BOOTW06	; RETRY BOOT
;
BOOTER0:
;	OTHERWISE TOO MANY RETRIES
	CALL	UILPRT
	DB	QKCR,QKLF,'** WARM BOOT ERROR',0
	JMP	BOOTWARM
;
;
;
; COMMON CODE FOR COLD AND WARM BOOT ROUTINES
;
BOOTCOM:
;
;	SET DEFAULT BUFFER ADDRESS 
	LXI	B,QLBUFF
	CALL	DSETDMA
;
; SET UP DISK BUFFER ADDRESS
;
	LXI	H,T@HSTBUF
	SHLD	W@HSTDMA
;
; SEND LAST LOGGED DISK NUMBER TO CCP
	LDA	QLCDISK	;LAST LOGGED DISK NUMBER
	MOV	C,A	;SEND TO CCP TO LOG IT IN
	JMP	QLCCP	; JUMP TO START OF CCP
;
;
; "BOOTINIT" - SUBROUTINE TO SET UP LOW MEMORY VECTORS,
;	       INITIALIZE RS232 PORTS AND SET VT-100
;		TO PROPER CONFIGURTION.
BOOTINIT:
;	RESET MONITOR ENTRY POINTS
	MVI	A,0C3H
	STA	0000
	LXI	H,QLBIOS+3
	SHLD	0001		; WA BOOT JUMP AT BASE + 0
	STA	0005
	LXI	H,QLBDOS
	SHLD	0006    	; BDOS JUMP AT BASE + 5
;
;
; SET INTERRUPT VECTORS
;
; SET UP RST2 AND RST3 FOR VT-180
;
	DI			; DISABLE INTERRUPTS
;
; RST 2 - RS232 RX READY
	STA	QLRST2		; STORE JMP
	LXI	H,I232RX	; HANDLER ADDRESS
	SHLD	QLRST2+1
; RST 3 - REAL TIME CLOCK
	STA	QLRST3		; STORE JMP
	LXI	H,ICLOCK	  ; HANDLER ADDRESS
	SHLD	QLRST3+1
;
;
; REINITIALIZE RST 7 VECTOR
;
	MVI	A,RET
	STA	QLRST7	;FORCE A RET (MAY HAVE BEEN CHANGED BY DDT)
;
; REINITIALIZE RS232 PORTS AND VT100
;
	CALL	P232INIT
	EI		; ENABLE INTERRUPTS
	RET		; EXIT
;
;
; "BOOTESC"  -  COLD BOOT ROUTINE TO ESCAPE FOM
;		"DEAD END" DISK SELECT PROBLEMS
BOOTESC:
	LDA	B@WBDRV	; GET BOOT DRIVE NUMBER
	STA	B@BDRIVE ; SET FOR READ
	MOV	C,A	; MOVE FOR CALL
	CALL	DPSELDR	; DO PHYSICAL SELECT
	LXI	H,4000H	; COLD BOOT LOCATION
	SHLD	W@HSTDMA  ; STORE FOR DISK READ
	CALL	DPRECAL	; GO TO TRACK ZERO
	ANA	A	; ERROR?
	JRNZ	BOOTESCX  ;   YES
	MVI	A,1	; SET SECTOR 1
	STA	B@BSEC
	CALL	DPREAD	; READ A PHYSICAL SECTOR
	ANA	A	; ERROR?
	JRNZ	BOOTESCX  ;   YES
	CALL	4000H	; GO DO COLD BOOT
;COLD BOOT RETURNS HERE IF ERROR OCCURS
BOOTESCX:
	CALL	UILPRT
	DB	QKCR,QKLF,'** COLD BOOT ERROR',0
	JMP	BOOTESC
;
;
;************************************************************
;*							    *
;*	   CHARACTER INPUT/OUTPUT ROUTINES		    *
;*							    *
;************************************************************
; CHARACTER INPUT/OUTPUT ROUTINES PERFORM ONE OF FOUR ACTIONS
; DEPENDING UPON THE SUFFIX APPLIED TO THE NAME.
;
;	IN	READS A CHARACTER; RETURNS IT IN REG. A
;	OUT	RITES A CHARACTER FROM REG. C
;	STI	RETURNS INPUT STATUS
;		  ZERO    - NO CHARACTER READY
;		  X'FF'   - CHARACTER READY
;	STO	RETURNS OUTPUT STATUS (CODES SAME AS STI)
;
;============================================================
;=							    =
;=		AUXILIARY DEVICE DRIVERS		    =
;=							    =
;============================================================
;
; NULL DEVICE DRIVERS FOR NON-IMPLEMENTED DEVICES
;
PNULIN:
	MVI	A,QKCTLZ	; INDICATE END OF FILE
	RET
;
PNULOUT:
	RET
;
PNULSTI:
	MVI	A,0FFH	; INDICATE DEVICE READY
	RET
;
PNULSTO EQU	PNULSTI
;
;
;
; RS232C DRIVER ROUTINES FOR VT-280
;
;
; CONTROL BLOCK OFFSETS
;
QTPORT		EQU	0	; CONTROL PORT NUMBER
QTFLAGS		EQU	1	; PORT FLAGS
QTNRCHR		EQU	2	; NR. OF CHARS CURRENTLY IN BUFFER
QTCAP		EQU	3	; BUFFER CAPACITY IN BYTES (CONSTANT)
QTINPTR		EQU	4	; BUFFER IPUT POINTER
QTOTPTR		EQU	5	; BUFFER OUTPUT POINTER
QTDEND		EQU	6	; OFFSET OF LAST DATA BYTE (CONSTANT)
QTDATA		EQU	7	; BUFFER DATAAREA
;
; CONTROL BLOCK EQUATES
;
; BIT MEANINGS FOR "QTFLAGS" BYTE
QBSUSP	EQU	0		; BIT NR. FOR SUSPEND FLAG
QBTYPE	EQU	1		; BIT NR. FOR PROTOCOL TYPE
				;   OFF = XON/XOFF, ARROW KEYS
				;   ON  = NO SUSP OR XLATE
;
;
; 8251 USART STATUS BITS
;
QMTXR		EQU	1	; TX READY
QMRXR		EQU	2	; RX READY
QMPARE		EQU	8	; PARITY ERROR
QMOVRE		EQU	10H	; OVERRUN ERROR
QMFRME		EQU	20H	; FRAMING ERROR (BREAK)
QMDSR		EQU	80H	; DSR ON
;
; 8251 STATUS BIT NUMBERS
;
QBTXR		EQU	0	; TX READY
QBRXR		EQU	1	; RX READY
QBPARE		EQU	3	; PARITY ERROR
QBOVRE		EQU	4	; OVERRUN ERROR
QBFRME		EQU	5	; FRAMING ERROR
QBDSR		EQU	7	; DSR (DTR) ON
;
; 8251 USART COMMAND BITS
;
QMCTXE		EQU	1	; TX ENABLE
QMCDTR		EQU	2	; DTR ON
QMCRXE		EQU	4	; RX ENABLE
QMCBRK		EQU	8	; SEND BREAK
QMCRSE		EQU	10H	; RESET ERROR 
QMCRTS		EQU	20H	; RTS ON
QMCIR		EQU	40H	; INTERNAL RESET
;
;
; 8251 USART MODE WORD BITS
;
QMMST1		EQU	40H	; 1 STOP BIT
QMMST15		EQU	8	; 1.5 STOP BITS
QMMST2		EQU	0C0H	; 2 STOP BITS
QMMEP		EQU	20H	; EVEN PARITY
QMMPAR		EQU	10H	; PARITY ENABLE
QMM5BIT		EQU	0	; 5 BITS/CHAR
QMM6IT		EQU	4	; 6 BITS/CHAR
QMM7BIT		EQU	8	; 7 BITS/CHAR
QMM8BIT		EQU	0CH	; 8 BITS/CHAR
QMMX1		EQU	1	; X1 CLOCK
QMMX16		EQU	2	; X16 CLOCK
QMMX64		EQU	3	; X64 CLOCK
;
;
; BAUD RATE CONSTANTS
;
QKB75		EQU	0	; 75 BAUD
QKB150		EQU	1	; 150 BAUD
QKB300		EQU	2	; 300 BAUD
QKB600		EQU	3	; 600 BAUD
QKB1200		EQU	4	; 1200 BAUD
QKB2400		EQU	5	; 2400 BAUD
QKB4800		EQU	6	; 4800 BAUD
QKB9600		EQU	7	; 9600 BAUD
;
;
; ASCII CONTROL CHARACTERS
;
QKBEL		EQU	7	; BEL
QKXON		EQU	17	; XON (CTL-Q)
QKXOFF		EQU	19	; XOFF (CTL-S)
QKSUB		EQU	26	; SUB
QKESC		EQU	27	; ESCAPE
QKLBR		EQU	'['	; LEFT BRACKET
;
;
; BIT MEANINGS FOR B@VTFLAGS
QBVT125		EQU	0	; BIT 0 - SET = VT125   RESET = VT100/132
QBPRINT		EQU	1	; BIT 1 - SET = PRINTER   RESET = CRT
;
;
;
; ==========================================================
;
;
; P232INIT   INITIALIZE PORTS
;
; FUNCTION:  INITIALIZES 232 PORT BAUD RATES AND MODES.
;
; ENTRY AND EXT PARAMETERS: N/A
;
P232INIT:
	LDA	B@232BAU	; BAUD RATE INITIALIZATION
	OUT	QPBAUD		; SET RATES
	LXIX	T@TTYCB		; POINT TO TTY CONTROL BLCK
	LDA	B@TTYMOD	; MODE BYTE
	CALL	P232PINT	; INITIALIZE TTY PORT
	LXIX	T@UC1CB		; POINT TO UC1 CONTROL BLOCK
	LDA	B@UC1MOD	; MODE BYTE
	CALL	P232PINT	; INITIALIZE UC1 PORT
	LXIX	T@PTRCB		; POINT TO PTR CONTROL BLOCK
	LDA	B@PTRMOD	; MODE BYTE
	CALL	P232PINT	; INITIALIZE PTR PORT
	CALL	PVT100IN	; REINITIALIZE VT-100
	RET
;
;
; P232PINT - INITIALIZE AN RS232C PORT
;
; FUNCTION: SUBROUTINE CALLED BY P232INT TO ITIALIZE ONE PORT
;
; NOTE: INTERRUPTS MUST BE DISABLED BEFORE CALLING 
;
; ENTRY:
;	IX = CONTROL BLOCK ADDRESS
;	A  = MODE BYTE
;
; EXIT:  N/A
;
P232PINT:
	LDX	C,QTPORT	; GET CONTROL PORT NR.
	STA	B@232MOD	; STORE MODE BYTE IN SEQUENCE
	LXI	H,T@232INT	; POINT T INIT. SEQUENCE
	MVI	B,QK232IL	; SET UP LENGTH
P232PI10:
	OUTI			; OUTPUT A BYTE
	XTHL			; DELAY
	XTHL
	JRNZ	P232PI10	; LOOP UNTIL ALL BYTES SENT
	DCR	C		; POINT TO DATA PORT
	INP	A		; READ TO CLEAR INTERRUPT
	INP	A
	RET
;
; INITIALIZATION SEQUENCE
T@232INT:
	DB	0,0,0,QMCIR	; KNOWN STATE AND RESET
B@232MOD:
	DB	0		; SLOT OR MODE BYTE
	DB	QMCTXE+QMCRXE+QMCDTR+QMCRSE  ; ENABLES
QK232IL	EQU	$-T@232INT	; SEQUENCE LENGTH
;
;
;
;
; PVT100SEQ  -  SEND CONTROL SEQUENCE TO VT100 TERMINAL
;
; ENTRY:  ADDRESS OF CONTROL SEQUENCE IS ON TOP OF STACK
;	  (SEQUENCE IMMEDIATELY FOLLOWS CALL INSTRUCTION)
;	  SEQUENCE ENDS WITH A ZERO BYTE.
;
; EXIT: RETURNS TO INSTRUCTION FOLLOWING END OF SEQUENCE.
;
 PVT100SEQ:
	POP	H		; GET ADDRESS OF BYTE
	MOV	A,M		; GET A BYTE
	INX	H		; INCREMENT POINTER
	ORA	A		; ZERO BYTE?
	JNZ	PVT100SQ1	;  NO - SEND IT
	PCHL			; RETURN ON ZERO BYTE
PVT100SQ1:
	MOV	C,A		; MOVE FOR CALL
	PUSH	H		; SAVE POINTER
	CALL	PCRTOUT1		; SEND CHARACTER TO VT100
	JMP	PVT100SEQ	; GET NEXT BYTE
;
;
;
;
; PVT100IN  -  REINITIALIZE VT100 TERMINA
; FUNCTION: SENDS CONTROL SEQUENCE TO VT100  REINITIALIZE
; IT ON BOOT.
; ENTRY: N/A
; EXIT: N/A
;
PVT100IN:
	CALL	PVT100SEQ	; SEND SEQUENCE
	DB	QKESC,'<'	;ANSI MODE
	DB	0
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	RES	QBPRINT,M	; SET FLAG TO CRT OUTPUT
	BIT	QBVT125,M	; VT-125 INSTALLED?
	CNZ	PVT100XC	;  YES - SET TO CRT OUTPUT
	CALL	PVT100SEQ	; DO REMAIND OF CONSOLE SETUP
	DB	QKESC,'>'	; KEYPAD NUMERIC MODE
	DB	QKESC,QKLBR,'?1;7l'  ; WRAP OFF, CURSOR MODE RESET
	DB	QKESC,QKLBR,'?8h'    ; AUTO REPEAT ON
	DB	QKESC,QKLBR,'20l'    ; AUTO NEW LINE OFF
	DB	0
	RET
;
;
;
; PVT100IQ  -  SEND INQUIRY SEQUENCE TO VT-100
; FUNCTION: SENDS SEQUENCE TO ASCERTAIN TERMINAL TYPE.
; ENTRY: N/A
; EXIT: N/A
;
PVT100IQ:
	CALL	PVT100SEQ
	DB	QKESC,QKLBR,'c'
	DB	0
; READ RESPONSE AND CHECK FOR VT-125 TERMINAL
	CALL	PCRTIN	; GET RESPONSE CHAR
	CPI	QKESC	; CHAR 1 = ESC?
	JRNZ	PVT100I1 ;  NO
	CALL	PCRTIN
	CPI	QKLBR	; CHR 2 = LEFT BRACKET?
	JRNZ	PVT100I1 ;  NO
	CALL	PCRTIN
	CPI	'?'	; CHAR 3 = '?'?
	JRNZ	PVT100I1 ;  NO
	CALL	PCRTIN
	CPI	'1'	; CHAR 4 = '1'?
	JRNZ	PVT100I1 ;  NO
	CALL	PCRTIN
	CPI	'2'	; CHAR 5 = '2'?
	JRNZ	PVT100I1 ; NO - NOT A VT-125
; SET FLAG BYTE TO INDICATE VT-125
	LXI	H,B@VTFLAGS
	SETB	QBVT125,M	; SET VT-125 BIT
; READ UNTIL END OF RPONSE SEQUENCE
PVT100I1:
	CPI	'c'	; END OF SEQUENCE?
	RZ		;  YES - EXIT
	CALL	PCRTIN	; READ NEXT
	JR	PVT100I1 ; TEST IT
;
; PVT100XC  -  SET VT125 TORT OUTPUT
;
PVT100XC:
	PUSH	B		; PRESERVE REG. C
	CALL	PVT100SEQ
	DB	QKESC,QKLBR,'4;7i'
	DB	0
	POP	B
      RET
;
;
; PVT100XP  -  SET VT125 TO PRINTER OUTPUT
;
PVT100XP:
	PUSH	B		; PRESERVE REG. C
	CALL	PVT100SEQ
	DB	QKESC,QKLBR,'5;6i'
	DB	0
	POP	B
	RET
;
;
;
; P232IN  -  READ A CHARACTER
;
; FUNCTION: RETURNS ONE BYTE FROM CIRCULAR BUFFER.  WAITS IF
;	    BUFFER IS EMPTY.
; ENTRY:  IX = CONTROL BLCK ADDRESS
; EXIT: A = CHARACTER
;
P232IN:
	LDX	A,QTNRCHR	; GET NR OF CHARACTERS IN BUFFER
	ANA	A		; IS IT ZERO?
	JRZ	P232IN		;  YES - WAIT UNTIL NON-ZERO
	DI			; DISABLE WHILE MANIPULATING BUFFER
	DCRX	QTNRCHR		; DECREMENT NR OF CHARACTERS
	LDX	E,QTOTPTR	; GET OUTPUT POINTER
	MVI	D,0		; MAKE 16-BIT
	INRX	QTOTPTR		; INCREMENT POINTER
	LDX	A,QTDEND	; GET MAX POINTER VALUE
	CMPX	QTOTPTR		; IS POINTER GTR THAN MAX?
	JRNC	P232IN4		;   NO
	MVIX	QTDATA,QTOTPTR	; SET IT BACK TO START OF BUFFER
P232IN4:
	DADX	DE		; ADD POINTER TO CTL BLOCK ADDR
	LDX	A,0		; GET CHARACTER FROM BUFFER
	EI			; NOW RE-ENABLE
	RET
;
;
; P232OUT  -  WRITE CHARACTER
; FUNCTION: WRITES A CHARACTER TO THE SPECIFI PORT
; ENTRY: 
;	IX = CONTROL BLOCK ADDRESS
;	C  = CHARACTER TO BE WRITTEN
; EXIT:  N/A
;
P232OUT:
	MOV	E,C		; SAVE TX CHARACTER
	LDX	C,QTPORT	; GET PORT NUMBER
; PREVENT XOFF FROM GOING TO CRT OR TTY
	BITX	QBTYPE,QTFLAGS	; CRT OR TTY?
	JRNZ	P232OUT1	;  NO - SEND EVERYTHING
	MOV	A,E		; GET CHARACTER
	ANI	7FH		; STRIP PARITY
	MOV	E,A		; SAVE IT AGAIN
	CPI	QKXOFF		; IS IT XOFF?
	RZ			;  YES - DON'T SEND IT
P232OUT1:
	INP	A		; GET PORT STATUS
	ANI	QMTXR		; IS TX READY?
	JRZ	P232OUT1	;  NO - WAIT UNTIL READY
P232OUT3:
	BITX	QBSUSP,QTFLAGS	; IS OUTPUT SUSPENDED?
	JRNZ	P232OUT3	;  YES - WAIT UNTIL ENABLED
; CHECK TX READY ONCE AGAIN (MAY HAVE BEEN LOWERED BY ERROR RESET)
	DI			; DISABLE 
P232OUT5:
	INP	A		; GET STATUS
	ANI	QMTXR		; TX READY?
	JRZ	P232OUT5	;  NO - WAIT FOR IT
	DCR	C		; POINT TO DATA PORT
	OUTP	E		; SEND CHARACTER
	EI			; RE-ENABLE INTERRUPTS
	RET
;
;
;
; P232STI  -  RETURN INPUT STATUS
;
; FUNCTION:  RETURNS A VALUE INDICATING WHETHER AN INPUT CHARACTER
;	    IS AVAILABLE FROM A SPECIFIED PORT.
;
; ENTRY:  IX = CONTROL BLOCK ADDRESS
;
; EXIT:
;	A = 0 IF NO CHARACTER IS READY (BUFFER EMPTY)
;	A = X'FF' IF ONE OR MORE CHARACTERS READY
;
P232STI:
	LDX	A,QTNRCHR	; GET NUMBER OF CHARACTERS IN BUFFER
	ANA	A		; IS IT ZERO?
	RZ			;   YES - EXIT
	MVI	A,0FFH		; SET CODE FO READY
	RET
;
;
;
; P232STO  -  RETURN OUTPUT STATUS
;
; FUNCTION: RETURNS A CODE INDICATING WHETHER THE SPECIFIED PORT
;	    IS READY TO ACCEPT AN OUTPUT CHARACTER.
;
; ENTRY:  IX = CONTROL BLOCK ADDRESS
;
; EXIT:
;	A  = 0 IF NOT READY TO ACCEPT A CHARACTER
;	A X'FF' IF READY TO ACCEPT A CHARACTER
;
P232STO:
	LDX	C,QTPORT	; GET PORT NUMBER
	INP	A		; READ STATUS
	ANI	QMTXR		; IS TX READY?
	RZ			;  NO - EXIT
	XRA	A		; SET TO "NOT READY"
	BITX	QBSUSP,QTFLAGS	; OUTPUT SUSPENDED?
	RNZ			;  YES - RETURN WITH NOT READY
	CMA			; SET TO READY
	RET
;
;
; RS232C PORT CONTROL BLOCKS
;
; BUFFER DATA LENGTHS
;
QKTTYBL	EQU	32	; TTY PORT
QKCRTBL	EQU	32	; CONSOLE PORT
QKPTRBL	EQU	1	; PTR PORT
QKUC1BL	EQU	1	; UC1 PORT
;
;
; TTY PORT CONTROL BLOCK
;
T@TTYCB:
	DB	QPTTY	; PORT NUMBER
	DB	0	; USES XON/XOFF
	DB	0	; NUMBER OF CHARACTERS
	DB	QKTTYBL	; BUFFER CAPACITY
	DB	QTDATA	; INPUT POINTER
	DB	QTDATA	; OUTPUT POINTER
	DB	QTDATA-1+QKTTYBL ; OFFSET OF LAST DATA BYTE
	DS	QKTTYBL	; DATA AREA
;
; CRT PORT CONTROL BLOCK
;
T@CRTCB:
	DB	QPCRT	; PORT NUM
	DB	0	; USES XON/XOFF
	DB	0	; NUMBER OF CHARACTERS
	DB	QKCRTBL	; BUFFER CAPACITY
	DB	QTDATA	; INPUT POINTER
	DB	QTDATA	; OUTPUT POINTER
	DB	QTDATA-1+QKCRTBL ; OFFSET OF LAST DATA BYTE
	DS	QKCRTBL	; DATA AREA
;
; PTR PORT CONTROL BLOCK
;
T@PTRCB:
	DB	QPPTR	; PORT NUMR
	DB	1 SHL QBTYPE ; NO XON/XOFF
	DB	0	; NUMBER OF CHARACTERS
	DB	QKPTRBL	; BUFFER CAPACITY
	DB	QTDATA	; INPUT POINTER
	DB	QTDATA	; OUTPUT POINTER
	DB	QTDATA-1+QKPTRBL ; OFFSET OF LAST DATA BYTE
	DS	QKPTRBL	; DATA AREA
;
; UC1 PORT CONTROL BLOCK
;
T@UC1CB:
	DB	QPUC1	; PORT NUMR
	DB	1 SHL QBTYPE ; NO XON/XOFF
	DB	0	; NUMBER OF CHARACTERS
	DB	QKUC1BL	; BUFFER CAPACITY
	DB	QTDATA	; INPUT POINTER
	DB	QTDATA	; OUTPUT POINTER
	DB	QTDATA-1+QKUC1BL ; OFFSET OF LAST DATA BYTE
	DS	QKUC1BL	; DATA AREA
;
;
;
;============================================================
;=							    =
;=		INTERRUPT HANDLERS			    =
;=							    =
;============================================================
;
;
; I232RX  -  HANDLE PORT RECEIVE INTERRUPTS
; FUNCTION: PROCESS RECEIVER INTERRUPTS FROM E OR MORE RS232C PORTS.
; ENTRY AD EXIT PARAMETERS: N/A
;
I232RX:
	SSPD	T@STACK		; SAVE STACK POINTER
	LXI	SP,T@STACK	; SET UP PRIVATE STACK
	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW
	PUSHIX
; POINT TO EACH PORT CONTROL BLOCK AND PROCESS RECEIVER
	LXIX	T@TTYCB		; TTY PORT
	CALL	I232RPT
	LXIX	T@CRTCB		; CONSOLE PORT
	CALL	I232RPT
	LXIX	T@PTRCB		; PTR PORT
	CALL	I232RPT
	LXIX	T@UC1CB		; UC1 PORT
	CALL	I232RPT
; RESTORE REGISTERS
	POPIX
	POP	PSW
	POP	B
	POP	D
	POP	H
	LSPD	T@STACK		; RESTORE STACK POINTER
	EI
	RET
;
;
;
; I232RPT  -  PROCESS RECEIVED CHARACTER 
; FUNCTION:  IF A CHARACTER IS READY IN A PORT RECEIVER, READS T
;	     AND PLACES IT IN CIRCULAR BUFFER. IF REQUIRED, PROCESS
;	     XON/XOFF PROTOCOL AND TRANSLATES ESCAPE SEQUENCES FOR
;	     ARROW KEYS ON VT-100.
; ENTRY:  IX = CONTROL BLOCK ADDRESS
;
I232RPT:
	LDX	C,QTPORT	; GET PORT NUMBER
	INP	B		; READ STATUS
	BIT	QBRXR,B		; IS RX READY?
	RZ			;   NO - EXIT
	DCR	C		; POINT TO DATA PORT
	INP	   A		; READ CHARACTER
	BIT	QBOVRE,B	; OVERRUN ERROR?
	JRZ	I232RP00	;  NO
	RESX	QBSUSP,QTFLAGS	; ENABLE OUTPUT (ASSUME XON LOST)
I232RP00:
	BIT	QBFRME,B	; BREAK CONDITION?
	JZ	I232RP03	;  NO
; DELAY FOR BREAK
	LXI	H,38500		; 250 MS DELAY
I232RP01:
	DCX	H		; DECREMENT DELAY COUNT
	MOV	A,H
	ORA	L		; IS COUNT ZERO?
	JRNZ	I232RP01	;  NOT YET
	INP	A		; CLEAR PORT
	JMP	I232RP13	; ENABLE OUTPUT, CLEAR ERROR, EXIT
I232RP03:
	BIT	QBPARE,B	; PARITY ERROR?
	JRZ	I232RP21	;  NO
	MVI	A,QKSUB		; CHANGE TO "SUB" 
I232RP21:
	BITX	QBTYPE,QTFLAGS	; PROCESS PROTOCOL?
	JNZ	I232RP20	;   NO - GO STORE CRACTER
	ANI	7FH		; STRIP PARITY
	JZ	I232RP40	; NULL CHAR - IGNORE
I232RP05:
	CPI	QKXOFF		; IS IT XOFF?
	JRNZ	I232RP10	;   NO
	SETX	QBSUSP,QTFLAGS	; SUSPEND OUTPUT
	JMP	I232RP40	; CLEAR ERRORS D EXIT
I232RP10:
	CPI	QKXON		; IS IT XON?
	JRNZ	I232RP15	;  NO - STORE IT
	BIT	QBOVRE,B	; OVERRUN ERROR?
	JRNZ	I232RP13	;  YES - ASSE XOFF WAS LOST
	BITX	QBSUSP,QTFLAGS	; IS OUTPUT SUSPENDED?
	JZ	I232RP20	;  NO - STORE XONN BUFFER
I232RP13:
	RESX	QBSUSP,QTFLAGS	; ENABLE OUTPUT
	JMP	I232RP40	; CLEAR ERRORS AND EXIT
;
; TRANSLATE ARROW KEYS INTO CONTROL CHARACTERS
;   LOOK FOR ESCAPE FOLLOWED BY LEFT BRACKET FOLLOWED 
;   BY 'A','B','C', OR 'D'. TRANSLATE INTO CONTROL
;   CHARACTERS USED BY WORDSTAR.
;
I232RP15:
	CPI	QKESC		; ESCAPE?
	JNZ	I232RP20	;  NO - STORE INTO BUFFER
	PUSH	B
	MVI	B,100		; SET UP 50 MS TIMEOUT
	CALL	I232RPRD	; READ CHARACTER WITH TIMEOUT
	POP	B
	JRNZ	I232RP16	;  GOT A CHARACTER
; NO CHARACTER FOLLOWED ESCAPE WITHIN TIME INTERVAL
	MVI	A,QKESC		; SET UP ESCAPE CHAR
	JMP	I232RP20	; STORE IT INTO BUFFR
; CHECK SECOND CHARACTER IN SEQUENCE - MUST BE LEFT BRACKET
I232RP16:
	CPI	QKLBR		; LEFT BRACKET?
	JRNZ	I232RP17	;  NO
	PUSH	B
	MVI	B,200		; SET UP 100 MS TIMEOUT
	CALL	I232RPRD	; READ CHARACTER WITH TIMEOUT
	POP	B
	JRNZ	I232RP18	; GOT A CHARACTER
	MVI	A,QKLBR		; SET UP LEFT BRACKET
; NOT AN ARROW KEY. STORE ESCAPE AND 2ND CHARACTER IN BUFFER
I232RP17:
	PUSH	PSW		; SAVE SECOND CHARACTER
	MVI	A,QKESC		; SET UP ESCAPE CHARACTER
	CALL	I232RP20	; STORE IT
	POP	PSW		; RESTORE SECOND CHARACTER
	JMP	I232RP05	; CHECK AND STORE T
; CHECK THIRD CHARACTER IN SEQUENCE - MUST BE 'A' THRU 'D'
I232RP18:
	CPI	'D'+1
	JRNC	I232RP19	; GREATER THAN 'D'
	CPI	'A'
	JRC	I232RP19	; LESS THAN 'A'
; GET TRANSLATION FROM TABLE AND STORE INTO BUFFER
	SUI	'A'		; MAKE IT A NUMBER 0-3
	MOV	E,A		; MAKE A 16 BIT OFFSET
	MVI	D,0
	LXI	H,T@ARCTL	; POINT TO XLATE TABLE
	DAD	D		; POINT TO ENTRY
	MOV	A,M		; GET TRANSLATION
	JMP	I232RP20	; STORE IT
; NOT AN ARROW KEY.  STORE ALL 3 CHARACTERS IN BUFFER
I232RP19:
	PUSH	PSW		; SAVE THIRD CHARACTER
	MVI	A,QKESC		; SET UP ESCAPE CHAR
	CALL	I232RP20	; STORE IT
	MVI	A,QKLBR		; SET UP LEFT BRACKET
	CALL	I232RP20	; STORE IT
	POP	PSW		; GET THIRD CHARACTER BACK
	JMP	I232RP05	; CHECK AND STORE IT
;
; STORE CHARACTER INTO BUFFER
;
I232RP20:
	MOV	C,A		; SAVE INPUT CHARACTER
	LDX	A,QTCAP		; GET BUFFER CAPACITY
	CMPX	   QTNRCHR		; IS BUFFER FULL?
	JRZ	   I232RP30		; YES
	INRX	   QTNRCHR		; INCREMENT NR OF CHARACTERS
I232RP22:
	LDX	E,QTINPTR	; GET INPUT POINTER
	MVI	D,0		; MAKE IT 16-BIT
	INRX	QTINPTR		; INCREMENT INPUT POINTER
	LDX	A,QTDEND	; GET OFFSET OF LAST BYTE
	CMPX	QTINPTR		; IS POINTER PAST END?
	JRNC	I232RP25	;  NO
	MVIX	QTDATA,QTINPTR	; SET POINTER TO START OF BUFFER
I232RP25:
	PUSHIX			; SAVE CONTROL BLOCK POINTER
	DADX	DE		; ADD OFFSET TO CTL BLOCK ADDRESS
	STX	C,0		; STORE CHARACTER
	POPIX			; RESTORE CONTROL BLOCK POINTER
	JP	I232RP40	; RESET ERRORS AND EXIT
;
; BUFFER IS FULL
;
I232RP30:
	BITX	QBTYPE,QTFLAGS	; CONSOLE OR TTY?
	JRNZ	I232RP22	;  NO - OK TO OVERLAY PREVIOUS CHARS.
	MVI	E,QKBEL		; GET READY TO SEND 'BEL'
	LDX	C,QTPORT	; GET STATUS PORT NUMBER
I232RP35:
	INP	A		; GET STATUS
	ANI	QMTXR		; IS TX READY?
	JRZ	I232RP35	;  NO - WAIT UNTIL READY
	DCR	C		; POINT TO DATA PORT
	OUTP	E		; WRITE B
	INR	C		; POINT TO CONTROL PORT
I232RP38:
	INP	A		; WAIT FOR TX READY TO COME HIGH
	ANI	QMTXR		; IS TX READY?
	JRZ	I232RP38	;  NO - WAIT
;
; CLEAR ERROR FLAGS AND EXIT
;
I232RP40:
	MVI	A,QMPARE+QMOVRE+QMFRME ; ERROR MASK
	ANA	B		; ANY ERRORS?
	RZ			;  NO - EXIT
I232RP43:
	LDX	C,QTPORT	; POINT TO ONTROL PORT
I232RP45:
	INP	A		; GET STATUS
	ANI	QMTXR		; READY FOR COMMAND?
	JRZ	I232RP45	;  NOT YET
	MVI	A,QMCRSE+QMCTXE+QMCRXE+QMCDTR+QMCRTS	 ;ENABLE
	OUTP	A		; RESET ERRORS
	RET
;
;
; I232RPRD  -  READ CHARACTER WITH TIMEOUT
;
; FUNCTION:  ATTEMPTS TO READ A CHARACTER FROM THE CURRENT PORT
; WITHIN A SPECIFIED TIME INTERVAL.  RETURNS EITHER WITH CHARACTER
; OR INDICATION OF TIMEOUT.
;
; ENTRY:
;	IX CONTAINS THE CONTROL BLOCK POINTER
;	B  CONTAINS THE TIME CONSTANT (UNITS OF 0.5 MS)
;
; EXIT:
; Z FLAG IS SET IF NO CHARATER READ BEFORE TIMEOUT
;	Z FLAG RESET IF CHARACTER WAS READ
;	A CONTAINS THE CHARACTER
;
I232RPRD:
	LDX	C,QTPORT	; CET CONTROL PORT NUMBER
I232RPR2:
	INP	A		; READ STATUS
	ANI	QMRXR		; RECEIVE READY?
	JRNZ	I232RPR4	;  YES
	PUSH	B
	MVI	B,154		; SET 0. MS TIMEOUT
I232RPR3:
	DJNZ	I232RPR3	; DELAY
	POP	B
	DJNZ	I232RPR2	; LOOPNTIL READ TIMEOUT
	RET			; RETURN WITH TIMEOUT
; READ THE CHARACTER
I232RPR4:
	DCR	C		; POINT TO DATA PORT
	INP	A		; READ CHARACTER
	ANI	7FH		; STRIP PARITY
	RET			; RETURN WITH Z FLAG RESET
;
;
;ARROW KEY TRANSLATION TABLE
;
T@ARCTL:
	DB	'E'-40H		; CTL-E   UP ARROW
	DB	'X'-40H		; CTL-X   DON ARROW
	DB	'D'-40H		; CTL-D   RIGHT ARROW
	DB	'S'-40H		; CTL-S   LEFT ARROW
;
;
; PRIVATE STACK AREA
;   USED TO ASSURE THAT INTERRUPT ROUTINE DOES NOT
;   OVERRUN THE APPLICATION'S STACK
;
		DS	30
T@STACK		DS	2		; STACK POINTER STORAGE
;
;
;
;
;
; REAL TIME CLOCK INTERRUPT HANDLER
;
ICLOCK:
	PUSH	PSW
	IN	QPRTRST	; DUMMY READ TO RESET INTERRUPT
	POP	PSW
	EI
	RET

	PAGE
;
;
;
;============================================================
;=							    =
;=		PHYSICAL DEVICE DRIVERS		   	    =
;=							    =
;============================================================
;
;
; "TTY:"  -  SERIAL I/O DEVICE
;
PTTYIN:
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	BIT	QBVT125,M	; VT-125?
	JNZ	PCRTIN		;  YES
	LXIX	T@TTYCB	; CONTROL BLOCK ADDRESS
	JMP	P232IN
PTTYOUT:
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	BIT	QBVT125,M	; IN VT-125 MODE?
	JRZ	PTTYOUT1	;  NO
	BIT	QBPRINT,M	; PRINTER OUTPUT?
	JRNZ	PCRTOUT1	;  YES - SEND TO CRT PORT
	SETB	QBPRINT,M	; SET PRINTER OUTPUT BIT
	CALL	PVT100XP	; SEND SEQ TO SET PRINTER OUTPUT
	JMP	PCRTOUT1	; SEND OUTPUT TO RT PORT
PTTYOUT1:
	LXIX	T@TTYCB
	JMP	P232OUT
PTTYSTI:
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	BIT	QBVT125,M	; VT-125?
	JNZ	PCRTSTI		;  YES
	LXIX	T@TTYCB
	JMP	P232STI
PTTYSTO:
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	BIT	QBVT125,M	; IN VT-125 MODE?
	JNZ	PCRTSTO		;  YES
	LXIX	T@TTYCB
	JMP	P232STO
;
;
; "CRT:"  -  VIDEO DISPLAY/KEYBOARD
;
PCRTIN:
	LXIX	T@CRTCB	; CONTROL BLOCK ADDRESS
	JMP	P232IN
PCRTOUT:
	LXI	H,B@VTFLAGS	; POINT TO FLAG BYTE
	BIT	QBVT125,M	; IN VT-125 MODE?
	JRZ	PCRTOUT1	;  NO
	BIT	QBPRINT,M	; PRINTER OUTPUT?
	JRZ	PCRTOUT1	;  NO
	RES	QBPRINT,M	; SET TO CRT OUTPUT
	CALL	PVT100XC	; SEND SEQ TO SWITCH TO CRT
;
; PCRTOUT1 IS USED AS ALTERNATE ENTRY POINT FOR DIRECT CRT OUTPUT
PCRTOUT1:
	LXIX	T@CRTCB
	JMP	P232OUT
      PCRTSTI:
	LXIX	T@CRTCB
	JMP	P232STI
       PCRTSTO:
	LXIX	T@CRTCB
	JMP	P232STO
;
;
; "UC1:"  -  USER CONSOLE DEVICE
;
PUC1IN:
	LXIX	T@UC1CB
	JMP	P232IN
PUC1OUT:
	LXIX	T@UC1CB
       JMP	P232OUT
PUC1STI:
	LXIX	T@UC1CB
	JMP	P232STI
;
;
; "PTR:"  -  READER DEVICE
;
PPTRIN:
	LXIX	T@PTRCB
	JMP	P232IN
PPTRSTI:
	LXIX	T@PTRCB
	JMP	P232STI
;
;
; "UR1:"  -  USER READER DEVICE 1
;
PUR1IN	EQU	PNULIN	; NULL DEVICE
PUR1STI	EQU	PNULSTI
;
;
; "UR2:"  -  USER READER DEVICE 2
;
PUR2IN	EQU	PNULIN	; NULL DEVICE
PUR2STI	EQU	PNULSTI
;
;
; "PTP:"  -  PUNCH DEVICE
;
PPTPOUT:
	LXIX	T@PTRCB
	JMP	P232OUT
;
;
; "UP1:"  -  USER PUNCH DEVICE 1
;
PUP1OUT	EQU	PNULOUT	; NULL DEVICE
;
;
; "UP2:"  -  USER PUNCH DEVICE 2
;
PUP2OUT	EQU	PNULOUT ; NULL DEVICE
;
;
; "LPT:"  -  PRINTER DEVICE
;
PLPTOUT:	EQU	PTTYOUT
PLPTSTO:	EQU	PTTYSTO
;
;
; "UL1:"  -  USER LIST DEVICE 1
;
PUL1OUT	EQU	PNULOUT	; NULL DEVICE
PUL1STO	EQU	PNULSTO

		PAGE
;
;
;
;
;============================================================
;=							    =
;=		 LOGICAL DEVICE DRIVERS			    =
;=							    =
;============================================================
;
;
;============================================================
;=							    =
;=		CONSOLE INPUT/OUTPUT		            =
;=							    =
;============================================================
;
; "CONIN"  -  INPUT A CHARACTER FROM CONSOLE 
;
CONIN:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMICON	; SAVE CONSOLE BITS
	JZ	PTTYIN	; 0 = TTY
	CPI	2
	JC	PCRTIN	; 1 = CRT
	JZ	CREADER	; 2 = BAT
	JMP	PUC1IN	; 3 = UC1
;
;
; "CONOUT"  -  OUTPUT A CHARACTER TO THE CONSOLE
;
CONOUT:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMICON	; SAVE CONSOLE BITS
	JZ	PTTYOUT	; 0 = TTY
	CPI	2
	JC	PCRTOUT	; 1 = CRT
	JZ	CLIST	; 2 = BAT
	JMP	PUC1OUT	; 3 = UC1
;
; "CONST"  -  RETURN CONSOLE INPUT STATUS
;
CONST:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMICON	; SAVE CONSOLE BITS
	JZ	PTTYSTI	; 0 = TTY
	CPI	2
	JC	PCRTSTI	; 1 = CRT
	JZ	CRDRST	; 2 = BAT
	JMP	PUC1STI	; 3 = UC1
;
;
;============================================================
;=							    =
;=		PRINTER (LIST) OUTPUT		            =
;=							    =
;============================================================
;
; "CLIST"  -  OUTPUT A CHARACTER TO LIST DEVICE
;
CLIST:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMILST	; SAVE LST BITS
	JZ	PTTYOUT	; 0 = TTY
	CPI	2 SHL 6
	JZ	PLPTOUT	; 2 = LPT
	JC	PCRTOUT	; 1 = CRT
	JMP	PUL1OUT	; 3 = UL1
;
; "CLISTST"  -  TEST LIST DEVICE OUTPUT STATUS
;
CLISTST:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMILST	; SAVE LST BITS
	JZ	PTTYSTO	; 0 = TTY
	CPI	2 SHL 6
	JZ	PLPTSTO	; 2 = LPT
	JC	PCRTSTO	; 1 = CRT
	JMP	PUL1STO	; 3 = UL1
;
;============================================================
;=							    =
;=		READER/PUNCH INPUT/OUTPUT		    =
;=							    =
;============================================================
;
;
; "CREADER"  -  INPUT A CHARACTER FROM THE READER DEVICE
;
CREADER:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMIRDR	; SAVE RDR BITS
	JZ	PTTYIN	; 0 = TTY
	CPI	2 SHL 2
	JC	PPTRIN	; 1 = PTR
	JZ	PURIN	; 2 = UR1
	JMP	PUR2IN	; 3 = UR2
;
;
; "CRDRST"  -  RETURN READER STATUS 
;		(NEEDED BY BAT: OPTION FOR CONSOLE)
;
CRDRST:
	LDA	QLIOBYT	; GET IOBYTE
	ANI	QMIRDR	; SAVE RDR BITS
	JZ	PTTYSTI	; 0 = TTY
	CPI	2 SHL 2
	JC	PPTRSTI	; 1 = PTR
	JZ	PUR1STI	; 2 = UR1
	JMP	PUR2STI	; 3 = UR2
;
; "CPUNCH"  -  OUTPUT A CHARACTER TO THE PUNCH DEVICE
;
CPUNCH:
        LDA	QLIOBYT	; GET IOBYTE
	ANI	QMIPUN	; SAVE PUN BITS
	JZ	PTTYOUT	; 0 = TTY
	CPI	2 SHL 4
	JC	PPTPOUT	; 1 = PTP
	JZ	PUP1OUT	; 2 = UP1
	JMP	PUP2OUT	; 3 = UP2
;
;************************************************************
;*							    *
;*		DISK INPUT/OUTPUT			    *
;*							    *
;=		DISK I/O TABLES				    =
;=							    =
;============================================================
;
	DISKS	QKNDISKS	; NUMBER OF DISKS SUPPORTED
;
; DEFINITION FOR SS/DD 40 TRACK MINI, 512 BYTE SECTORS @ 9/TRACK
;
	DISKDEF	0,1,QKSECTRK,1,1024,171,64,64,2
;
; DEFINITIONS FOR OTHER DISKS OF SAME TYPE
@DISKN	SET	0
	REPT	QKNDISKS-1
@DISKN	SET	@DISKN+1
	DISKDEF	%@DISKN,0
	ENDM
;
; SECTOR TRANSLATE TABLE FOR PHYSICAL DISK OF 9 SECTORS
; OF 512 BYTES EACH. PHYSICAL SKEW FACTOR = 2.
;
	ORG	XLT0	; OVERLAY TABLE MADE BY DISKDEF
;
	DB	0,1,2,3
	DB	8,9,10,11
	DB	16,17,18,19
	DB	24,25,26,27
	DB	32,33,34,35
	DB	4,5,6,7
	DB	12,13,14,15
	DB	20,21,22,23
	DB	28,29,30,31
;
;
;
; EQUATES FOR BLOCK/DEBLOCK CODE
;
;
;
;	UTILITY MACRO TO COMTE SECTOR MASK
SMASK	MACRO	HBLK
;;	COMPUTE LOG2(HBLK), RETURN  AS RESULT
;;	(2 ** @X = HBLK ON RETURN)
@Y	SET	HBLK
@X	SET	0
;;	COUNT RIGHT SHIFTS OF @Y UNTIL = 1
	REPT	8
	IF	@Y = 1
	EXITM
	ENDIF
;;	@Y IS NOT 1, SHIFT RIGHT ONE POSITION
@Y	SET	@Y SHR 1
@X	SET	@X + 1
	ENDM
	ENDM
;
QKHSTSIZ	EQU	512		;HOST DISK SECTOR SIZE
QKHSTBLK	EQU	QKHSTSIZ/128	;CP/M SECTS/HOST BUFF
QMSECMSK	EQU	QKHSTBLK-1	;SECTOR MASK
	SMASK	QKHSTBLK		;COMPUTE SECTOR MASK
QKSECSHF	EQU	@X		;LOG2(QKHSBLK)
QKALLOCB	EQU	1024		; ALLOCATION BLOCK SIZE
;
QKWRALL	EQU	0		;WRITE TO ALLOCATED
QKWRDIR	EQU	1		;WRITE TO DIRECTORY
QKWRUAL	EQU	2		;WRITE TO UNALLOCATED
QKREAD	EQU	0FFH		; READ (EXTENSION)
;
;
;
;
;===========================================================
;=							   =
;=		LOGICAL DISK IO ROUTINES		   =
;=							   =
;===========================================================
;
;
DHOME:
;	TREAT AS TRACK 0 SEEK
	LXI	B,0
	JMP	DSETTRK
;
DSELDSK:
	LXI	H,0		; CLEAR HL
	MOV	A,C
	CPI	QKNDISKS	;TOO LARGE?
	JNC	DPSELD90	; YES - INVALID DISK
	STA	B@DRIVE	; STORE DRIVE NUMBER
	MOV	L,C	; HL = DRIVE NUMBER
	DAD	H	;*2
	DAD	H	;*4
	DAD	H	;*8
	DAD	H	;*16
	LXI	D,DPBASE
	DAD	D	;HL=DISK HEADER TABLE ADDRESS
	RET
;
; INVALID DISK DRIVE SELECT
;
DPSELD90:
	CALL	UILPRT
	DB	QKCR,QKLF,'INVALID DISK SELECT - '
	DB	'CONTROL-C TO RE-BOOT',0
DPSELD95:
	CALL	CONIN		; GET RESPONSE
	CPI	QKCTLC		; IS IT CONTROL-C?
	JZ	BOOTESC		;  YES - RE-BOOT
	JMP	DPSELD95	; IGNORE AND CHECK AGAIN
;
;
DSETTRK:
	MOV	L,C
	MOV	H,B
	SHLD	W@TRACK
	RET
;
DSETSEC:
	LXI	H,B@SECTOR
	MOV	M,C
	RET
      ;
DSECTRAN:
;TRANSLATE SECTOR BC USING TABLE AT DE
	MVI	B,0	;DOUBLE PRECISION SECTOR NUMBER IN BC
	XCHG		;TRANSLATE TABLE ADDRESS TO HL
	DAD	B	;TRANSLATE(SECTOR) ADDRESS
	MOV	L,M	;RETURN SECTOR NUMBER IN L
	MVI	H,0
	RET
;
DSETDMA:
	MOV	L,C
	MOV	H,B
	SHLD	W@DMA
	RET
;
DREAD:
	MVI	A,QKREAD	; SET CODE TO "READ"
	STA	B@WRTYPE
	CALL	DBMGT		; DO BUFFER MANAGEMENT
	ORA	A		; ERROR?
	RNZ			;  YES - EXIT
	LHLD	W@BADDR		; GET DATA ADDRESS IN BUFFER
	LDED	W@DMA		; GET TARGET ADDRESS
	LXI	B,128		; NUMBER OF BYTES TO MOVE
	LDIR			; MOVE DATA FROM BUFFER
	XRA	A		; SET STATUS = OK
	RET			; EXIT
;
;
DWRITE:
	MOV	A,C		; GET WRITE CODE FROM BDOS
	STA	B@WRTYPE	; SAVE IT
	CALL	DBMGT		; DO BUFFER MANAGEMENT
	ORA	A		; ERROR?
	RNZ			;  YES - EXIT
	LHLD	W@DMA		; GET SOURCE ADDRESS
	LDED	W@BADDR		; GET TARGET ADDRESS IN BUFFER
	LXI	B,128		; NUMBER OF BYTES TO MOVE
	LDIR			; MOVE DATA INTO BUFFER
	LDA	B@WRTYPE	; GET WRITE TYPE
	CPI	QKWRDIR		; DIRECTORY WRITE?
	JRZ	DWRITE10	;  YES
	MVI	A,1
	STA	B@WRFLAG	; SETBUFFER WRITE FLAG
	XRA	A		; SET STATUS = OK
	RET			; EXIT
DWRITE10:
	XRA	A
	STA	B@WRFLAG	; RESET WRITE FLAG
	CALL	DBWRITE		; WRITE THE DIRECTORY SECTOR
	RET
;
;
;
;
;
; BUFFER MANAGEMENT
; LOCATES DATA IN BUFFER.  EMPTIES BUFFER AND PRE-READS
; SECTOR IF NECESSARY.
;
DBMGT:
; COMPUTE DESIRED PHYSICAL SECTOR NUMBER
	LDA	B@SECTOR	; GET LOGICAL SECTOR NUMBER
	ANI	NOT QMSECMSK	; CLEAR LW ORDER BITS
	REPT	QKSECSHF	; SHIFT IT
	RRC
	ENDM
	INR	A		; INCREMENT FOR FIRST SECTOR = 1
	STA	B@DPSEC		; STORE ASESIRED PHYS. SECTOR
; COMPUTE DATA ADDRESS IN BUFFER
	LDA	B@SECTOR	; GET LOGICAL SECTOR NUMBER
	ANI	QMSECMSK	; MOD BY PHYSICAL SECT SIZE
	MOV	L,A
	MVI	H,0		; MAKE 16 BIT NR
	REPT	7		; MULTIPLY BY 128
	DAD	H
	ENDM
	LXI	D,T@HSTBUF	; GET BUFFER BASE ADDRESS
	DAD	D		; ADD OFFSET
	SHLD	W@BADDR		; STORE AS FFER ADDRESS
; DETERMINE WHETHER BUFFER CONTAINS DESIRED SECTOR
	LDA	B@BDRIVE	; BUFFER DRIVE
	LXI	H,B@DRIVE	; DESIRED DRIVE
	CMP	M		; ARE THEY THE SAME?
	JNZ	DBMGT10		;  NO
	LHLD	W@BTRACK	; BUFFER TRACK
	LBCD	W@TRACK		; DESIRED TRACK
	ANA	A		; CLEAR CARRY
	DSBC	BC		; ARE THEY THE SAME?
	JNZ	DBMGT10		;  NO
	LDA	B@BSEC		; BUFFER PHYSICAL SECTOR
	LXI	H,B@DPSEC	; DESIRED PHICAL SECTOR
	CMP	M		; ARE THEY THE SAME?
	JNZ	DBMGT10		;  NO
; BUFFER CONTAINS DESIRED SECTOR
	XRA	A		; SET STATUS = OK
	RET			; EXIT
;
; BUFFER NEEDS TO BE REFRESHED
;
DBMGT10:
	LDA	B@WRFLAG	; GET BUFFER WRITE FLAG
	ORA	A		; IS IT SET?
	JRZ	DBMGT20		;  NO
	XRA	A		; CLEAR WRITE FLAG
	STA	B@WRFLAG
	CALL	DBWRITE		; EMPTY THE BUFFER
DBMGT20:
	ORA	A		; EROR?
	RNZ			;  YES - EXIT
	LDA	B@DRIVE		; DESIRED DRIVE
	STA	B@BDRIVE	; SET AS BUFFER DRIVE
	LHLD	W@TRACK		; DESIRED TRACK
	SHLD	 W@BTRACK	; SET AS BUFFER TRACK
	LDA	B@DPSEC		; DESIRED PHSICAL SECTOR
	STA	B@BSEC		; SET AS BUFFER SECTOR
	LDA	B@WRTYPE	; GET WRITE TYPE
	CPI	QKWRUAL		; FIRST WRITE TO UNALLOC. BLOCK?
	JNZ	DBMGT30		;  NO
; SET VARIABLES FOR UNALLOCATED BLOCK
	MVI	A,QKALLOCB/QKHSTSIZ-1
	STA	B@UACNT		; SET COUNT OF PHYSICAL SECTORS
	LDA	B@DRIVE
	STA	B@UADRV		; SET DRIVE
	LHLD	W@BTRACK
	SHLD	W@UATRK		; SET TRACK
	LDA	B@BSEC
	STA	B@UASEC		; SET STARTING SECTOR
	XRA	A		; SET STATUS = OK
	RET			; EXIT
;
; IF ORDINARY WRITE, CHECK TO SEE IF IN UNALLOCATED BLOCK
;
DBMGT30:
	CPI	QKWRALL		; ORDINARY WRITE?
	JNZ	DBMGT50		;  NO
	LDA	B@UACNT		; GET REMAINING COUNT
	ORA	A		; IS IT ZERO?
	JZ	DBMGT55		;  YES - NEED TO READ
	DCR	A		; DECREMENT COUNT
	STA	B@UACNT		; STORE IT
	LDA	B@UASEC		; GET UNALLOC. SECTOR NR
	LXI	H,T@NEXTLOG-1	; POINT TO NEXT SECOR TABLE
	MOV	E,A		; MAKE SECTOR NR 16-BIT
	MVI	D,0
	DAD	D		; ADD IT TO TABLE BASE
	MOV	A,M		; GET NR OF NEXT SECTOR
	STA	B@UASEC		; SAVE IT
	CPI	1		; IS IT FIRST SECTOR (OF NEXT TRACK?)
	JRNZ	DBMGT35		;  NO - ON SAME TRACK
	LHLD	W@UATRK		; INCREMENT TRACK NUMBER
	INX	H
	SHLD	W@UATRK
DBMGT35:
	LXI	H,B@BDRIVE	; BUFFER DRIVE
	LDA	B@UADRV		; UNALLOCATED BLOCK DRIVE
	CMP	M		; ARE THEY THE SAME?
	JNZ	DBMGT50		;  NO
	LHLD	W@BTRACK	; BUFFER TRACK
	LBCD	W@UATRK		; UNALLOCATED TRACK
	ANA	A		;  (CLEAR CARRY)
	DSBC	BC		; ARE THEY THE SAME?
	JNZ	DBMGT50		;  NO
	LXI	H,B@BSEC	; BUFFER SECTOR
	LDA	B@UASEC		; UNALLOCATED SECTOR
	SUB	 M		; ARE THEY THE SAME?
	RZ			;  YES - EXIT WITH OK STATUS
; CLEAR UNALLOCATED COUNT
DBMGT50:
	XRA	A
	STA	B@UACNT
; READ A PHYSICAL SECTOR
DBMGT55:
	CALL	DBREADH		; READ SECTOR
	RET			; EXIT WITH STATUS
;
; TABLE GIVING, FOR ANY PHYSICAL SECTOR, THE PHYSICAL SECTOR WHICH
;  CONTAINS THE NEXT LOGICAL SECTOR
T@NEXTLOG:
	DB	3,4,5,6,7,8,9,1,2
;
;
;
;
;
;
; READ A PHYSICAL SECTOR
;
DBREADH:
	CALL	DRDWRSET	; SET UP FOR READ
	MVI	A,1	; SET UP FOR ERROR EXIT
	RNZ		; EXIT IF SEEK ERROR OCCURRED
	CALL	DPREAD	; READ A SECTOR
	PUSH	PSW	; SAVE RETURN CODE
	ORA	A	; TEST RETURN
	CNZ	DEMRD	; DISPLAY MESSAGE IF ERROR
	POP	PSW
	RET		; EXIT WITH STATUS
;
;
;
;
; WRITE A PHYSICAL SECTOR
;
DBWRITE:
	CALL	DRDWRSET	; SET UP FOR WRITE
	MVI	A,1	; SET UP FOR ERROR EXIT
	RNZ		; RETURN IF SEEK ERROR OCCURRED
	CALL	DPWRITE	; WRITE A SECTOR
	PUSH	PSW	; SAVE RETURN CODE
	ORA	A	; TEST RETURN
	CNZ	DEMWR	; DISPLAY MESSAGE IF ERROR
	POP	PSW
	RET		; EXIT WITH STATUS
;
;
;
;
;
;
; DRDWRSE  -  SET UP FOR DISK READ OR WRITE
;
; PERFORM SEEK IF NECESSARY FOR PHYSICAL READ/WRITE
;
; ENTRY : N/A
;
; EXIT: Z FLAG IS SET IS SEEK IS SUCCESSFUL ( UNNECESSARY)
;       Z FLAG IS CLEAR IF SEEK OR RESTORE ERROR OCCURRED
;
DRDWRSET:
	LDA	B@BDRIVE ; GET DESIRED DRIVE
	MOV	C,A
	CALL	DPSELDR	; SELECT DRIVE
	CALL	DPWTRDY	;WAIT UNTIL DRIVE IS READY
	LXI	H,T@TRACK  ; POINT TO TRACK TABLE
	LDA	B@BDRIVE	; GET DRIVE NUMBER
	MOV	E,A	; MOVE DRIVE NR TO DE
	MVI	D,0
	DAD	D	; OFFSET INTO TRACK TABLE
	MOV	A,M	; GET CURRENT TRACK
	CPI	0FFH	; FIRST TIME DRIVE ACCESSED?
	JNZ	DRDWR20	;   NO
; RECALIBRATE DRIVE
	PUSH	H	; SAVE TRACK TABLE POINTER
	CALL	DPRECAL	; DO RECL.
	ORA	A	; TEST RETURN CODE
	PUSH	PSW	; SAVE RETURN
	CNZ	DEMRC	; DISPLAY MESSAGE IF ERROR
	POP	PSW
	POP	H	; RESTORE TRACK TABLE POINTER
	RNZ		; EXIT IF ERROR ON RECL.
	MVI	M,0	; SET CURRENT TRACK TO ZERO
DRDWR20:
	LDA	W@BTRACK	; GET DESIRED TRACK NUMBER
	CMP	M	; SAMAS CURRENT TRACK?
	RZ		;  YES - NO SEEK NECESSARY
; SEEK TO DESIRED TRACK
	PUSH	H	; SAVE TRACK TABLE POINTER
	CALL	DPSEEK	; DO SEEK
	ORA	A	; TEST RETURN CODE
	PUSH	PSW	; SAVE RETURN CODE
	CNZ	DEMSK	; DISPLAY MESSAGE IF ERROR
	POP	PSW
	POP	H	; RESTORE TRACK TABLE POINTER
	RNZ		; EXIT ON HARD EK ERROR
	LDA	W@BTRACK	; GET DESIRED TRACK NUMBER
	MOV	M,A	; STORE IN TRACK TABLE
	RET
;
;
;
;
;
; DISK ERROR MESSAGE ROUTINES
;
; READ ERROR
;
DEMRD:
	CALL	UILPRT
	DB	QKCR,QKLF,'READ',0
	JR	DEMRW		; COMPLETE THE MESSAGE
;
; WRITE ERROR
;
DEMWR:
	CALL	UILPRT
	DB	QKCR,QKLF,'WRITE',0
;
; COMMON CODE FOR READ AND WRITE ERRORS
;
DEMRW:
	CALL	DEMSK10		; DISPLAY DRIVE AND TRACK INFO
	CALL	UILPRT
	DB	  'SECTOR ',0
	LDA	B@BSEC	; GET SECTOR NUMBER
	JR	DEMSK20		; DISPLAY SECTOR NR
;
; SEEK ERROR
;
DEMSK:
	CALL	UILPRT
	DB	QKCR,QKLF,'SEEK',0
DEMSK10:
	CALL	DEMRC10		; ISPLAY DRIVE INFO
	CALL	UILPRT
	DB	'  TRACK ',0 
	LDA	W@BTRACK
; GET TRACK NUMBER
DEMSK20:
	CALL	UDECOUT		; OUPUT DECIMAL NUMBER
	RET
;
; RESTORE ERROR
;
DEMRC:
	CALL	UILPRT
	DB	QKCR,QKLF,'RESTORE',0
DEMRC10:
	CALL	UILPRT
	DB	' ERROR - DRIVE ',0
	LDA	B@BDRIVE		; GET DRIVE NUMBER
	ADI	'A'		; MAKE IT A LETTER
	MOV	C,A		; MOVE FOR CALL
	CALL	CONOUT		; DISPLAY IT
	RET
;
;
; CURENT TRACK TABLE
T@TRACK:
	DB	0FFH
	DB	0FFH
	DB	0FFH
	DB	0FFH
;
;
;
;============================================================
;=							    =
;=		PHYSICAL DISK I/O ROUTINES		    =
;=							    =
;============================================================
;
; THESE ROUTINES ARE CONTROLLER-DEPENDENT AND USE AS INPUT PARAMETERS
; THE DATA IN B@BDRIVE, W@BTRACK, B@BSEC, AND W@HSTDMA. THE ROUTINES
; DPREAD, DPWRITE, DPRECAL, AND DPSEEK PERFORM ERROR DETTION AND
; RECOVERY.  IF A HARD ERROR EXISTS, A NON-ZERO BYTE IS RETURNED
; IN REGISTER A.  IF THE OPERATION COMPLETES SUCCESSFULLY, A ZERO
; BYTE IS RETURNED IN A. DPWTRDY AND DPSELDR DO NOT RETURN STATUS.
;
; EQUATES FOR WD 1793 CONTROLLER
;
; FDC COMMAND FLAGS
;
QMHLD	 EQU	8	; HEAD LOAD FLAG
QMVERF	EQU	4	; VERIFY FLAG
QMEFLG	EQU	4	; HEAD LOAD FLAG FOR READ/WRITE
QMSSEL	EQU	8	; SIDE SELECT FLAG
QMSCOM	EQU	2	; SIDE COMPARE FLAG
QMUPDT	EQU	10H	; UPDATE TRACK REG FLAG
;
; FDC STEP RATE
;
QKRATE	EQU	1	; 6 MS RATE
;
; FDC COMMANDS
;
QCREST		EQU	0+QMHLD+QKRATE		; RESTORE (RECAL)
QCSEEK		EQU	10H+QMHLD+QKRATE+QMVERF	; SEEK
QCSTEPIN      	EQU	40H+QMHLD+QKRATE+QMUPDT ; STEP IN
QCREADS       	EQU	80H			; READ SECTOR
QCWRTS		EQU	0A0H			; WRITE SECTOR
QCTERM		EQU	0D0H			; TERMINATE COMMAND
QCFINDX       	EQU	0D4H			; FORCE INT. ON INDEX PULSE
;
; DISK CONTROLLER STATUS - TYPE 1 COMMANDS
;
QMNRDY		EQU	80H	; NOT READY 
QMWPROT       	EQU	40H	; WRITE PROTECTED
QMHLT	 	EQU	20H	; HEAD LOADED
QMSKERR       	EQU	10H	; SEEK ERROR
QMCRC	 	EQU	8	; CRC ERROR
QMTZERO       	EQU	4	; TRACK ZERO
QMINDEX       	EQU	2	; INDEX
QMBUSY		EQU	1	; CONTROLLER BUSY
;
; DISK CONTROLLER STATS - TYPE 2 COMMANDS
;
QMWRFLT      	EQU	20H	; WRITE FAULT
QMRNF		EQU	10H	; RECORD NOT FOUND
QMLDATA      	EQU	4	; LOST DATA
QMDRQ		EQU	2	; DATA REQUEST
;
; ERROR MASKS FOR OPERATIONS
;
QMSEEK	EQU	QMNRDY+QMSKERR+QMCRC		; SEEK
QMREST	EQU	QMNRDY+QMSKERR			; RESTORE
QMREAD	EQU	QMNRDY+QMRNF+QMCRC+QMLDATA  	; READ SECTOR
QMWRITE EQU	QMREAD+QMWRFLT+QMWPROT		; WRITE SECTOR
;
; MISCELLANEOUS EQUATES
;
QKDRETRY    EQU	4	; DISK OPERATION RETRIES
QMSDEN      EQU	4	; SINGLE DENSITY BIT (QPSTAT)
QMON        EQU	8	; MOTOR ON BIT (QSTAT)
QKDRCNT     EQU	40000	; COUNT FOR DISK READY TIMING (.5 SEC)
;
;
;
;
; DPREAD  -  READ ONE SECTOR
;
; FUNCTION: READS ONE SECTOR FROM DISK. RETRIES WHEN ERROR IS
; ENCOUNTERED.  DISPLAYS ERROR MESSAGE FOR HARD ERROR.
;
; ENTRY: SECTOR NUMBER IS IN B@BSEC. DMA ADDRESS IS IN W@HSTDMA.
;
; EXIT:
;	A = ZERO FOR SUCCESSFUL COMPLETION
;	A IS NONZERO FOR UNCORRECTABLE ERROR
;		(LOST DATA, CRC ERROR, RECORD NOT FOUND)
;
DPREAD:
	MVI	A,QKDRETRY
	STA	B@RWTRY		; INITIALIZE RETRY COUNT
	LXI	H,DPREADX
	SHLD	W@RDWRT		; STORE ROUTINE ADDRESS
	CALL	DPREADX		; PERFORM READ OPERATION
	RZ			; RETURN IF SUCCESSFUL
	JMP	DPRWERR		; ERROR RECOVERY ROUTINE
;
;
; DPREADX  -  PHYSICAL READ ROUTINE
;
; PERFORMS READ D 1793 CONTROLLER) AND TESTS FOR ERRORS.
; ON EXIT, Z FLAG IS SET IF READ IS ERROR-FREE
;
DPREADX:
	MVI	E,QCREADS	; SET UP READ COMMAND
	CALL	DPRWSET		; SET UP FDC AND SEND COMMAND
DPREADX1:
	IN	QPSTAT		; GET FDC GENERAL STATUS
	ADD	A		; SHIFT INT. BIT TO SIGN
	JM	DPREADX2	; JUMP IF DONE
	JRNC	DPREADX1	; LOOP IF NO DRQ
	INI			; READ A BYTE
	JR	DPREADX1	; WAIT FOR NEXT BYTE
DPREADX2:
	EI			; RE-ENABLE INTERRUPTS
	IN	QPCOMD		; GET READ STATUS
	ANI	QMREAD		; MASK ERRORS
	RET			; EXIT WITH STATUS
;
;
;
; DPWRITE  -  WRITE A SECTOR
;
; FUNCTION:  WRITES ONE SECTOR TO ISK.  RETRIES IF ERRORS
; ENCOUNTERED.  
;
; ENTRY: SECTOR NUMBER IS IN B@BSEC. MEMORY ADDRESS IS IN W@HSTDMA
;
; EXIT:
;	A = ZERO FOR SUCCESUL COMPLETION
;	A IS NONZERO FOR HARD WRITE ERROR
;	 (LOST DATA, WRITE FAULT, RECORD NOT FOUND)
;
DPWRITE:
	MVI	A,QKDRETRY
	STA	B@RWTRY		; INITIALIZE RETRY COUNT
	LXI	H,DPWRTX
	SHLD	W@RDWRT		; STORE ROUTINE ADDRESS
	CALL	DPWRTX		; PERFORM WRITE
	RZ			; RETURN IF SUCCESSFUL
	JMP	DPRWERR		; ERROR RECOVERY
;
;
; DPWRTX - WRITE ONE PHYSICAL SECTOR
;
; WRIS ONE SECTOR TO DISK (WD 1793 CONTROLLER). TESTS
; FOR ERRORS.  ON EXIT, Z FLAG IS SET FOR SUCCESSFUL WRITE.
;
DPWRTX:
	MVI	E,QCWRTS	; SET UP WRITE COMMAND
	CALL	DPRWSET		; SET UP C AND SEND COMMAND
DPWRTX1:
	IN	QPSTAT		; GET FDC GENERAL STATUS
	ADD	A		; SHIFT INT. BIT TO SIG
	JM	DPWRTX2		; EXIT LOOP ON INTERRUPT
	JRNC	DPWRTX1		; LOOP IF NO DRQ
	OUTI			; WRITE ONE BYTE
	JR	DPWRTX1		; WAIT FOR NEXT DRQ
DPWRTX2:
	EI			; RE-ENABLE INTERRUPTS
	IN	QPCOMD		; GET FDC STATUS
	ANI	QMWRITE		; MASK ERRORS
	RET			; EXIT WITH STATUS
;
;
;
; DPRWERR - DISK READ/WRITE ERROR RECOVERY
;
; ENTRY: READ/WRITE ROUTINE ADDRESS IS IN W@RDWRT
;
; EXIT: 
;	A = ZERO IF RECOVERY IS SUCCESSFUL
;	A IS NONZERO IF HA ERROR EXISTS
;
DPRWERR:
	MOV	B,A	; SAVE ERROR CODES
	MVI	A,QCTERM
	OUT	QPCOMD	; TERMINATE COMMAND
	MOV	A,B		; GET ERROR CODES
	ANI	QMCRC+QMRNF	; CRC ERROR OR RNF?
	JRNZ	DPRWE20		;  YES - PROCESS IT
	MOV	A,B		; GET ERROR CODES AGAIN
	ANI	QMLDATA		; LOST DATA?
	JRNZ	DPRWE10		;  YES - REPEAT OPERATION
	MVI	A,0FFH		; SIGNAL A HARD ERROR
	RET			; EXIT
;
; REPEAT OPERATION UNTIL RETRY COUNT IS EXHAUSTED
;
DPRWE10:
	LXI	H,B@RWTRY	; POINT TO RETRY COUNTER
	DCR	M		; DECREMENT IT
	MVI	A,0FFH		; SET UP CODE FOR HARD ERROR
	RZ			; EXIT IF COUNT EXHAUSTED
	LHLD	W@RDWRT		; GET I/O ROUTINE ADDR
	CALL	DPRWE90		; EXECUTE IT
	RZ			; EXIT IF SUCCESSFUL
	JR	DPRWE10		; TRY AGAIN
;
; REPEAT OPERATION, THEN PERFORM ADVANCED RECOVERY
;
DPRWE20:
	CALL	DPRWE10		; REPEAT OPERATION
	ANA	 A		; TEST RETURN CODE
	RZ			; EXIT IF SUCCESSFUL
; RESTORE DRIVE, SEEK AGAIN AND DO OPERATIOONCE MORE
	CALL	DPRECAL		; RESTORE
	ANA	A		; TEST RETURN
	RNZ			; HARD RESTORE ERROR
	CALL	DPSEEK		; SEEK TO TRACK
	ANA	A		; TEST RETURN
	RNZ			; ARD SEEK ERROR
	LHLD	W@RDWRT		; GET I/O ROUTINE ADDR
	CALL	DPRWE90		; EXECUTE IT
	RET			; EXIT FROM RECOVERY
;
; INDIRECT CALL
DPRWE90:
	PCHL
;
;
;
; DPRECAL  -  RESTORE DRIVE
;
;FUNCTION: RETURNS THE HEAD TO TRACK ZERO ON THE CURRENT DRIVE
;
; ENTRY: N/A
;
; EXIT:
;	A = ZERO FOR SUCCESUL COMPLETION
;	A IS NONZERO FOR HARD RESTORE ERROR
;
DPRECAL:
	CALL	DPRECALX	; PERFORM RESTORE
	RZ			; EXIT IF SUCCESSFUL
; ERROR RECOVERY - STEP IN FIVE TIMES AND REPEAT
	MVI	B,5		; SET NR OF STEPS
DPRECAL1:
	MVI	A,QCSTEPIN
	CALL	DPCOMD		; STEP IN ONCE
	DJNZ	DPRECAL1	; REPEAT
	CALL	DPRECALX	; RESTORE AGAIN
	RET			; EXIT WITH STATUS
;
;
; DPRECAL - DO RESTORE OPERATION
;
DPRECALX:
	MVI	A,QCREST
	CALL	DPCOMD		; EXECUTE RESTORE
	IN	QPCOMD		; GET FDC STATUS
	MOV	C,A		; SAVE STATUS
	ANI	QMTZERO		; AT TRACK ZERO?
	JRNZ	DPRECALX1	;  YES
	CMA
	ANA	A		; SET NONZERO STATUS
	RET			; EXIT - NOT AT TRACK ZO
DPRECALX1:
	MOV	A,C		; GET STATUS BACK
	ANI	QMREST		; MASK ERRORS
	RET			; RETURN WITN STATUS
;
;
;
; DPSEEK  -  SEEK TO TRACK
;
; FUNCTN: SEEKS TO THE DESIRED TRACK.  TESTS FOR ERRORS AND
; RETRIES IF NECESSARY.
;
; ENTRY:  DESIRED TRACK NUMBER IS IN W@BTRACK
;
; EXIT:
;	A = 0 FOR SUCCESSFUL COMPLETION
;	A IS NONZERO FOR HA SEEK ERROR
;
DPSEEK:
	CALL	DPSEEKX		; DO SEEK OPERATION
	RZ			; EXIT IF SUCCESSFUL
; ERROR RECOVERY - RESTORE AND SEEK AGAIN
	CALL	DPRECAL		; RESTORE DRIVE
	ANA	A		; TEST RETURN
	RNZ			; HARD RESTORE ERROR
	CALL	DPSEEKX		; TRY SEEK AGAIN
	RET			; RETURN WITH STATUS
;
;
; DPSEEKX - PERFORM SEEK OPERATION (WD 1793 CONTROLLER)
;
; PERFORMS PHYSICAL SEEK OPERATION.  ON EXIT,Z FLAG IS 
; SET IF SEEK IS SUCCESSFUL.
;
DPSEEKX:
	LDA	W@BTRACK	; GET DESIRED TRACK NUMBER
	OUT	QPDATA		; SEND IT TODC
	MVI	A,QCSEEK
	CALL	DPCOMD		; EXECUTE SEEK
	MVI	C,20		; DELAY FOR HEAD SETTLING
	CALL	 UDELAY
	IN	QPCOMD		; GET FDC STATUS
	ANI	QMSEEK		; MASK ERRORS
	RET			; RETURN WITH STATUS
;
;
;
; DPWTRDY  -  WAIT UNTIL DRIVE BECOMES READY
;
; FUNCTION: TESTS TO SEE IF SELECTED DRIVE IS READY.  IF IT IS NOT,
; DISPLAYS A MESSAGE ON CONSOLE AND WAITS FOR OPERATOR RESPSE.
; EXITS WHEN DRIVE IS READY.
;
; ENTRY:  N/A
;
; EXIT:  N/A
;
DPWTRDY:
	IN	QPCOMD		; GET CONTROLLER STATUS
	ANI	QMBUSY		; BUSY?
	JNZ	DPWTRDY		;  YES - WAIT UNTIL NOT BUSY
	MVI	A,QCTERM	; FORCE TYPE 1 STATUS
	OUT	QPCOMD
	LXI	H,QKDRCNT	; SET UP TIMING COUNT
	XTHL			; DELAY BEFORE READI STATUS
	XTHL
	XTHL
	XTHL
	LDA	B@DRCHG		; GET DRIVE CHANGE INFO
	ORA	A		; WAS THERE A DRIVECHANGE ON SELECT?
	JRNZ	DPWTRD10	;  YES - IGNORE HEAD LOAD
	IN	QPCOMD		; GET STATUS
	ANI	QMHLT		; HEAD LOADED?
	RNZ			; YES - DISK IS READY
DPWTRD10:
	IN	QPSTAT		; GET SELECT BYTE
	ORI	QMON		; TURN MOTOR ON
	OUT	QPSTAT
	IN	QPCOMD		; GET STATUS
	ANI	QMINDEX		; ISOLATE INDEX BIT
	MOV	B,A		; SAVE IT
DPWTRD20:
	DCX	H		; DECREMENT TIMING OUNT
	MOV	A,H
	ORA	L		; IS IT ZERO?
	JRZ	DPWTRD30	;  YES - DISK IS NOT READY
	IN	QPCOMD		; GET STATUS AGAIN
	ANI	QMINDEX		; ISOLATE INDEX BIT
	CMP	B	       ; HAS INDEX CHANGED?
	JZ	DPWTRD20	;  NO - KEEP TESTING
	RET			; EXIT - DISK IS READY
; DISK IS NOT READY
DPWTRD30:
	CALL	UILPRT		; DISPLAY MESSAGE
	DB	QKCR,QKLF,'DRIVE ',0
	LDA	B@BDRIVE	; GET DESIRED DRIVE
	ADI	'A'		; MAKE IT A LETTER
	MOV	C,A		; MOVE FOR CALL
	CALL	CONOUT		; DISPLAY IT
	CALL	 UILPRT
	DB	' NOT READY - TYPE ANY KEY TO RETRY'
	DB	'  -  CONTROL-C TO RE-BOOT',0
	CALL	 CONIN		; GET RSPONSE
	CPI	QKCTLC		; CONTROL-C?
	JZ	BOOTESC		;  YES - REBOOT
	JMP	DPWTRD10	; RE-CHECK FOR READY
;
;
;
;
; DPSELDR  -  SELECT DRIVE
;
; FUNCTION: PHYSICALLY SELECTS THE DESIRED DRIVE.  SETS THE
; DENSITY BIT ALSO.
;
; ENTRY: DRIVE NUMBER IS IN REG. C
;
; EXIT:  N/A
;
DPSELDR:
	IN	QPSTAT		; GET DRIVE SELECT BYTE
	ANI	3		; ISOLATE DRIVE NUMBER
	SUB	C		; SAME AS DESIRED DRIVE?
	STA	B@DRCHG		; STORE DRIVE CHANGE INFO
	RZ			;YES - DO NOTHING
	MOV	A,C		; GET DESIRED DRIVE
	ORI	QMON		;ENSURE DISK DRIVE MOTORS ALWAYS ON.
	OUT	QPSTAT		; SEND IT TO PORT
	ANI	NOT QMON	;USED AS PURE DISK DRIVE NUMBERS
	MVI	C,70		; DEALY FOR HEAD SETTLING
	CALL	UDELAY
; ST 1793 TRACK REGISTER
	LXI	H,T@TRACK	; POINT TO TRACK TABLE
	MOV	E,A		; MOVE DRIVE NR TO DE
	MVI	D,0
	DAD	D		; OFFSET INTO TRACK TABLE
	MOV	A,M		; GET TRACK FOR THIS DRIVE
	CPI	0FFH		; DRIVE NOT ACCESED YET?
	RZ			;  YES - DON'T SET IT
	OUT	QPTRKRG		; SET TRACK IN 1793
	RET
;
;
;
; DPCOMD - EXECUTE A TYPE 1 COMMAND ON THE WD 1793 CONTROLLER
;
; WAITS UNTIL COMMAND IS COMPLETED BEFORE RETURNING
;
; ENTRY: COMMAND CODE IS IN "A" REG.
;
DPCOMD:
	OUT	QPCOMD		; SEND CMAND TO FDC
DPCOMD1:
	IN	QPSTAT		; GET GENERAL FDC STATUS
	ADD	A		; SHIFT INT. BIT TO SIGN
	RM			; EXIT ON INTERRUPT
	JR	DPCOMD1		; LOOP UNTIL DONE
;
;
;
; DPRWSET - SET UP FDC AND SEND TYPE 2 (READ/WRITE) COMMAND
;
; FUNCTION: SENDS SECTOR TO FDC. ADDS HEAD LOAD BIT TO COMMAND
; IF HEAD IS NOT ALREADY LOADED. SETS UP REGISTERS FOR INI AND
; OUTI INSTRUCTIONS. SENDS COMMAND TO FDC.
;
; ENTRY:  FDC COMMAND IS IN "E" REG. SECTOR IS IN B@BSEC.
;
; EXIT:  N/A
;
DPRWSET:
	IN	QPCOMD		; GET CONTROLLER STATUS
	ANI	QMBUSY		; BUSY?
	JZ	DPRWSET		;  YES - WAIT UNTIL NOT BUSY
	MVI	A,QCTERM		; SEND TERMINATE CMD
	OUT	QPCOMD			;  TO FORCE TYPE 1 STATUS
	MVI	C,QPDATA		; SET UP DTA PORT NUMBER
	LHLD	W@HSTDMA		; SET UP MEMORY ADDRESS
	LDA	B@BSEC			; GET SECTOR NUMBER
	OUT	QPSECRG			; SEND IT TO FDC
	XTHL				; DELAY BEFORE STATUS READ
	XTHL
	XTHL
	XTHL
	DI				; DISABLE FOR DISK I/O
	IN	QPCOMD			; GET FDC STATUS
	ANI	QMHLT			; HEAD ALREADY LOADED?
	MOV	A,E			; GET COMMAND
	JRNZ	DPRWSET4		;  HEAD IS ALREADY LOADED
	ORI	QMEFLG			; ADD HEAD LOAD FLAG
DPRWSET4:
	OUT	QPCOMD			; SEND TO FDC
	RET
;
;
;
;
	PAGE
;============================================================
;=							    =
;=		    UTILITY SUBROUTINES			    =
;=							    =
;============================================================
;
; UTILITY ROUTINE TO PRINT INLINE TEXT
;   TEXT FOLLOWS CALL INSTRUCTION AND ENDS WITH ZERO BYTE
;
UILPRT:
	POP	H	; GET ADDRESS OF CHARACTER
	MOV	A,M	; GET CHARACTER
	INX	H	; INCREMENT POINTER
	ORA	A	; ZERO BYTE?
	JNZ	UILPRT10  ;   NO - PRINT IT
	PCHL		; RETURN ON ZERO BYTE
UILPRT10:
	MOV	C,A	; MOVE FOR CALL
	PUSH	H	; SAVE POINTER
	CALL	CONOUT	; DISPLAY CHARACTER
	JMP	UILPRT	; GET NEXT CHARACTER
;
; UDECOUT -  DISPLAY A DEIMAL NUMBER
;
; ENTRY:  A = A BINARY NUMBER LESS THAN 100
;
UDECOUT:
	CPI	100		; IS IT LESS THAN 100?
	JRNC	UDEC90		;  NO - ERROR
	MVI	B,0		; INITIALIZE TENS COUNTER
UDEC10:
	SUI	10		; SUBTRACT 10
	JRC	UDEC20		; JUMP IF OVERFLOW
	INR	B		; INCREMENT TENS COUNT
	JR	UDEC10		; REPEAT UNTIL OVERFLO FC9D+18F9
UDEC20:
	ADI	10		; RESTORE UNITS ALUE
	PUSH	PSW		; SAVE UNITS VALUE
	MOV	A,B		; GET TENS COUNT
	ANA	A		; IS IT ZERO?
	CNZ	UDEC50		;  NO - DISPLAY IT
	POP	PSW		; GET UNITS VALUE BACK
UDEC50:
	ADI	'0'		; MAKE IT DISPLAYABLE
	MOV	C,A		; MOVE FOR CALL
UDEC55:
	CALL	CONOUT		; DISPLAY IT
	RET
; NUMBER GREATER THAN 100 - DSPLAY ASTERISK
UDEC90:
	MVI	C,'*'
	JR	UDEC55
;
;
;
;
; UDELAY  -  SOFTWARE DELAY SUBROUTINE
;
; RETURNS AFTER NUMBER OF MILLISECONDS SPECIFD IN REG C.
;
; ENTRY:  REG. C = NUMBER OF MILLISECONDS TO DELAY
;
; EXIT: (REG. C IS ZERO; ALL OTHERS PRESERVED)
;
UDELAY:
	PUSH	B	; SAVE BC
	MVI	B,0	; SET FOR 256 COUNTS
UDEL1:
	DJNZ	UDEL1	; DELAY
	MVI	B,48	; SET REMAINING 48 COUNTS
UDEL2:
	DJNZ	UDEL2	; DELAY
	POP	B	; RESTORE BC
	DCR	C	; DECREMENT MS. COUNT
	RZ		; RETURN IF DONE
	JR	UDELAY	; DELAY AGAIN
;
;
;************************************************************
;*							    *
;*		DATA AREAS (UNINITIALIZED)		    *
;*							    *
;************************************************************
;
;
; DISK ROUTINE WORKING STORAGE
;
B@DRIVE		DS	1	; CURRENT DRIVE NUMBER
W@TRACK		DS	2	; SELECTED TRACK
B@SECTOR	DS	1	; SELECTED SECTOR
W@DMA		DS	2	; DISK MEMORY ADDRESS
;
;
;
; DISK BLOCK/DEBLOCK WORKING STORAGE
;
;
;
B@WRTYPE:       DS	1		;WRITE OPERATION TYPE
B@WRFLAG	DS	1		; SET WHEN BUFFER MUST BE WRITTEN
B@DPSEC		DS	1		; DESIRED PHYSICAL SECTOR
W@BADDR		DS	2		; BUFFER DATA ADDRES
W@HSTDMA	DS	2		; PHYSICAL READ/WRITE ADDRESS
;
; BUFFER CONTENTS IDENTITY
;
B@BDRIVE	DS	1		; LOGICAL DRIVE
W@BTRACK	DS	2		; LOGICAL TRACK
B@BSEC		DS	1		; PHYSICAL SECTOR
;
; VARIABLES FOR TRACKING UNLOCATED BLOCKS
;
B@UACNT		DS	1	; COUNT OF REMAINING UNALLOC PHYS. SECTORS
B@UADRV		DS	1	; DRIVE CONTAINING UNALLOCATED BLOCK
W@UATRK		DS	2	; TRACK CONTAINING UNALLOCATED BLOCK
B@UASEC		DS	1	; PHYSICAL SECOR IN UNALLOCATED BLOCK
;
T@HSTBUF:	DS	QKHSTSIZ		;HOST BUFFER
;
;
;
; PHYSICAL DISK I/O WORKING STORAGE
;
B@RWTRY		DS	1	; R/W RETRY COUNTER
W@RDWRT		DS	2	; R/W ROUTINE ADDRESS
B@DRCHG		DS	1	; NON-ZERO IF DRIVE CHANGED ON SELECT
;
; WARM BOOT DRIVE NUMBER
;
B@WBDRV		DS	1
;
;
; DISK ALLOCATION AND CHECKVECTORS
;
;
	END	QLBIOS

